Package: MIRA
Version: 1.32.0
Date: 2021-11-21
Title: Methylation-Based Inference of Regulatory Activity
Description: DNA methylation contains information about the regulatory state of the cell.
	MIRA aggregates genome-scale DNA methylation data into a DNA methylation profile
	for a given region set with shared biological annotation. Using this profile,
	MIRA infers and scores the collective regulatory activity for the region set.
	MIRA facilitates regulatory analysis in situations where classical regulatory
	assays would be difficult and allows public sources of region sets to be
	leveraged for novel insight into the regulatory state of DNA methylation
	datasets.
Authors@R: c(person("Nathan", "Sheffield", role=c("aut")),
	person("John", "Lawson", email="jtl2hk@virginia.edu", role=c("aut", "cre")),
	person("Christoph", "Bock", role=c("ctb")))
Author: Nathan Sheffield <http://www.databio.org> [aut],
    Christoph Bock [ctb],
    John Lawson [aut, cre]
Maintainer: John Lawson <jtl2hk@virginia.edu>
Depends: R (>= 3.5)
Imports: BiocGenerics, S4Vectors, IRanges, GenomicRanges, data.table,
        ggplot2, Biobase, stats, bsseq, methods
Suggests: knitr, parallel, testthat, BiocStyle, rmarkdown,
        AnnotationHub, LOLA
VignetteBuilder: knitr
License: GPL-3
biocViews: ImmunoOncology, DNAMethylation, GeneRegulation,
        GenomeAnnotation, SystemsBiology, FunctionalGenomics, ChIPSeq,
        MethylSeq, Sequencing, Epigenetics, Coverage
URL: http://databio.org/mira
BugReports: https://github.com/databio/MIRA
RoxygenNote: 6.1.0
git_url: https://git.bioconductor.org/packages/MIRA
git_branch: RELEASE_3_22
git_last_commit: bb55c9a
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
NeedsCompilation: no
Packaged: 2025-10-30 05:06:51 UTC; biocbuild

# MIRA (Methylation-based Inference of Regulatory Activity)
[![Build Status](https://travis-ci.org/databio/MIRA.svg?branch=master)](https://travis-ci.org/databio/MIRA)

The MIRA package aggregates DNA methylation across the genome for instances of a genomic feature like histone ChIP peaks, transcription factor ChIP peaks, or open chromatin regions in order to give a single signature and score for that feature, which may be used to infer regulatory activity.


### Installing MIRA

MIRA may be installed from Github:

```{r}
devtools::install_github("databio/MIRA")
```

or locally after downloading/cloning the source code:

```{r}
install.packages("path/to/MIRA/directory", repos=NULL, type="source")
```


### Learning how to use MIRA

A couple of vignettes are included with the package. For an overview of the package see the "Getting Started" vignette. A more realistic example of how to use MIRA may be found in the "BiologicalApplication" vignette.

This submodule was downloaded from https://github.com/rwightman/efficientdet-pytorch/tree/v0.2.4. It is included in this package purely to avoid the dependency on pycocotools (which is difficult to install on Windows).

#####################################################################
#Binning and aggregation functions
#BSAggregate is primary function for this and workhorse of MIRA
#####################################################################



#' Bins regions and aggregates methylation data across the regions by bin
#' 
#' First bins regions and averages the proportion of methylation for
#' all methylation sites within each bin (ie  the methylation of 
#' all sites within region 1, bin 1 are averaged, then all sites 
#' within region 1, bin 2 are averaged, etc.)
#' Then aggregates methylation across all regions by bin by averaging
#' the proportion of methylation in each corresponding 
#' bin (ie all bin1's together, all bin2's together, etc.). 
#'
#' 
#' @param BSDT A single data table that has DNA methylation data 
#' on individual sites including a "chr" column with chromosome, 
#' a "start" column with the coordinate number for the cytosine, 
#' a "methylProp" column with proportion of methylation (0 to 1), 
#' optionally a "methylCount" column with number of 
#' methylated reads for each site, and 
#' optionally a "coverage" column with total number of reads for each site
#' (hasCoverage param).
#' @param rangeDT A data table with the sets of regions to be binned, 
#' with columns named "start", "end". Strand may also be given and will
#' affect the output. See "Value" section.
#' @param binNum Number of bins across the region.
#' @param byRegionGroup Default TRUE will aggregate methylation over 
#' corresponding bins for each region (all bin1's aggregated, all bin2's, etc).
#' byRegionGroup = FALSE is deprecated.
#' @param minBaseCovPerBin Filter out bins where the sum of coverage values is
#' less than X before returning.
#' @param splitFactor With default NULL, aggregation will be done 
#' separately/individually for each sample.
#' @param hasCoverage Default TRUE. Whether there is a coverage column
#' 
#' @return With splitFactor = NULL, it will return a data.table 
#' with binNum rows, 
#' containing aggregated methylation data over regions in region set "rangeDT".
#' Each region was split into bins; methylation was put in these bins; 
#' Output contains sum of the all corresponding bins 
#' for the regions of each region set ie for all regions in each region set: 
#' first bins summed, second bins summed, etc.
#' Columns of the output should be "bin", "methylProp", and, if
#' coverage was included as input col, "coverage"
#' 
#' Info about how strand of rangeDT affects output:
#' The MIRA profile will be symmetrical if no strand information is given for 
#' the regions (produced by averaging the profile with the reverse of the 
#' profile), because the orientation of the regions is arbitrary with respect 
#' to biological features (like a promoter for instance) that could be 
#' oriented directionally (e.g. 5' to 3'). If strand information is given, 
#' regions on the minus strand will be flipped before being aggregated 
#' with plus strand regions so the MIRA profile will be in 
#' 5' to 3' orientation.
#' @examples
#' data("exampleBSDT") # exampleBSDT
#' data("exampleRegionSet") # exampleRegionSet
#' exampleBSDT <- addMethPropCol(exampleBSDT)
#' aggregateBins <- BSBinAggregate(BSDT = exampleBSDT, 
#'                              rangeDT = exampleRegionSet, 
#'                              binNum = 11, splitFactor = NULL)
#' 
#' @export
BSBinAggregate <- function(BSDT, rangeDT, binNum, minBaseCovPerBin = 500, 
                          byRegionGroup = TRUE, splitFactor = NULL,
                          hasCoverage = TRUE) {
    
    # BSDT should not be a list but can be converted
    if (is(BSDT, "list")) {
        if (length(BSDT) == 1) {
            BSDT <- BSDT[[1]]
        } else {
            stop(cleanws("Only one BSDT may be given to function. 
                 BSDT should not be a list."))
        }
    }
    if (!is(BSDT, "data.table")) {
        stop("BSDT must be a data.table")
    }
    
    
    # if given GRanges object, change to DT
    if (is(rangeDT, "GRanges")) {
        rangeDT <- grToDt(GR = rangeDT, includeStrand = TRUE)
    }
    
    if (!is(rangeDT, "data.table")) {
        stop("rangeDT must be a data.table")
    }
    seqnamesColName <- "seqnames"  # default column name
    if ("chr" %in% colnames(rangeDT)) {
        # message("seqnames column name set to: chr")
        seqnamesColName <- "chr"
    } else {
        # Got neither.
        stop("rangeDT must have a seqnames or chr column")
    }
    
    if (! ("strand" %in% colnames(rangeDT))) {
        rangeDT[, strand := "*"]
        warning("Since strand not given, set to '*' ")
    }
    
    ## if (!silent) {
    # message("Binning...")
    ##}
    binnedDT <- rangeDT[, binRegion(start, end, 
                                   binNum, get(seqnamesColName), strand)]
    binnedGR <- sapply(split(binnedDT, binnedDT$binID), dtToGr)
    # message("Aggregating...")
    if (hasCoverage) {
        # aggregate methylation (mean) and sum coverage values
        aggrJCommand <- buildJ(c("methylProp", "coverage"), 
                              c("mean", "sum"))
    } else {
        # if no coverage only aggregate methylation level
        aggrJCommand <- buildJ("methylProp", "mean")
    }
    binnedBSDT <- BSAggregate(BSDT = BSDT, 
                             regionsGRL = GRangesList(binnedGR), 
                             jCommand = aggrJCommand, 
                             byRegionGroup = byRegionGroup, 
                             splitFactor = splitFactor,
                             hasCoverage = hasCoverage)
    
    # binnedBSDT will be NULL if there was absolutely no overlap between
    # region set and BSDT
    # don't do some of the following steps if there is no overlap/binnedBSDT is NULL
    if (is.null(binnedBSDT)) {
        warning(cleanws("No overlap between sample (BSDT) and region set. 
                    Returning NULL for this sample, region set combination."))
    } else {
        # If we aren't aggregating by bin, then don't restrict to min reads!
        if (byRegionGroup) {
            if (hasCoverage) {
                # only keep rows (bins) with coverage >= minBaseCovPerBin
                binnedBSDT <- binnedBSDT[coverage >= minBaseCovPerBin, ]
            }
            if (NROW(binnedBSDT) < binNum) {
                # telling user what sample failed if sample name is in BSDT
                if ("sampleName" %in% names(BSDT)) {
                    thisSample <- BSDT[1, sampleName]
                } else {
                    thisSample <- "this sample"
                }
                
                warning(paste0("Less than minBaseCovPerBin. Unable to return bins for ", 
                               thisSample, " for this region set."))
            }
        }
    }
    
    return(binnedBSDT)
}

# BSaggregate: Aggregate a BSDT across regions or region groups, 
# for multiple samples at a time.
# This function is as BScombineByRegion, but can handle not only multiple
# samples in BSDT, but also simultaneously multiple region sets by passing
# a regionsGRL (GRangesList object).However currently code for symmetrical 
# averaging will cause it to only work with one region set (which may be
# split up into multiple GRanges in a GRangesList).
# you can use jCommand to do other functions.

# Given a bisulfite data table as input, with an identifier column for
# different samples; plus a GRanges objects with regions to aggregate.
#
# @param BSDT The bisulfite data.table (output from one of the parsing
# functions for methylation calls) that you wish to aggregate. It can
# be a combined table, with individual samples identified by column passed
# to splitFactor. "chr", "start", "methylCount" columns should be in BSDT.
#  "coverage", and "methylProp" columns are optional (hasCoverage
# must be set to FALSE if there is not coverage column)
# @param regionsGRL Regions across which you want to aggregate.
# @param excludeGR A GenomicRanges object with regions you want to 
# exclude from the aggregation function. These regions will be eliminated
# from the input table and not counted.
# @param regionsGRL.length Vector with number of regions in each bin.
# From bin1 to binN. With default NULL value, it will be auto assigned.
# @param splitFactor Used to make "by string" to be plugged into a data.table
# "by=" statemnt. With default NULL value, by string will be "list(regionID)"
# @param keepCols Deprecated, NULL value should be used for MIRA aggregation.
# @param sumCols Deprecated, NULL value should be used for MIRA aggregation.
# @param jCommand You can pass a custom command in the j slot to data.table
# specifying which columns to aggregate, and which functions to use. You
# can use buildJ() to build a jCommand argument easily. jCommand may be
# used twice so changing column names in the jCommand could introduce errors
# @param byRegionGroup You can aggregate by regionID or by regionGroupID; 
# this reflects the regionsGRL that you pass; by default, BSAggregate will
# aggregate each region individually -- scores will then be contiguous, and
# the output is 1 row per region.
# Turn on this flag to aggregate across all region groups, making the result
# uncontiguous, and resulting in 1 row per *region group*. 
# (byRegionGroup=TRUE is used for normal MIRA behaviour that 
# aggregates across regions by bins 
# -- all bin1's together, all bin2's together etc.--, in which case
# "region group" in the description above refers to bin number,
# and you would have 1 row per bin)
# @param keep.na Not used in general MIRA context.
# @param hasCoverage Default TRUE. Assuming there is a coverage column
# unless told otherwise
# 
# @return In context of MIRA, with byRegionGroup = TRUE and jCommand = 
# list( methylProp = mean(methylProp), coverage = sum(coverage) )", 
# this function will return a data.table with 
# binNum rows (parameter for BSBinAggregate)
# containing aggregated methylation from BSDT over binned regions from a region
# set.
#
BSAggregate <- function(BSDT, regionsGRL, excludeGR = NULL, 
                       regionsGRL.length = NULL, splitFactor = NULL, 
                       keepCols = NULL, sumCols = NULL, jCommand = NULL, 
                       byRegionGroup = FALSE, keep.na = FALSE, hasCoverage = TRUE) {
    
    # Assert that regionsGRL is a GRL.
    # If regionsGRL is given as a GRanges, we convert to GRL
    if (is(regionsGRL, "GRanges")) {
        regionsGRL <- GRangesList(regionsGRL);
    } else if (!is(regionsGRL, "GRangesList")) {
        stop("regionsGRL is not a GRanges or GRangesList object");
    }
    
    # make sure methylProp column is present
    if (!("methylProp" %in% colnames(BSDT))) {
        stop("BSDT must have a methylProp column.")
    }
    
    if (! is.null(excludeGR)) {
        BSDT <- BSFilter(BSDT, minReads = 0, excludeGR)
    }
    
    bsgr <- BSdtToGRanges(list(BSDT));
    
    colModes <- sapply(BSDT, mode);
    if (is.null(sumCols)) {
        sumCols <- setdiff(colnames(BSDT), c("chr", "start", "end", 
                                            "strand", splitFactor, keepCols))
        # Restrict to numeric columns.      
        sumCols <- intersect(sumCols, 
                            names(colModes[which(colModes == "numeric")]))
        
    }
    # It's required to do a findoverlaps on each region individually, 
    # Not on a GRL, because of the way overlaps with GRLs work. So, 
    # we must convert the GRL to a GR, but we must keep track of which
    # regions came from which group.
    regionsGR <- unlist(regionsGRL)
    
    if (is.null(regionsGRL.length)) {
        if (length(regionsGRL) > 100) {
            message(cleanws("BSAggregate: Calculating sizes. You can speed this
                             up by supplying a regionsGRL.length vector..."),
                             appendLF = FALSE)
        }
        regionsGRL.length <- sapply(regionsGRL, length)
        # message("Done counting regionsGRL lengths.");
    }
    
    # Build a table to keep track of which regions belong to which group
    region2group <- data.table(
        regionID = seq_along(regionsGR), 
        chr = as.vector(seqnames(regionsGR)), 
        start = as.vector(start(regionsGR)), 
        end = as.vector(end(regionsGR)), 
        withinGroupID = as.vector(unlist(sapply(regionsGRL.length, seq))), 
        regionGroupID = rep(seq_along(regionsGRL), regionsGRL.length))
    setkey(region2group, regionID)
    
    
    # message("Finding overlaps...");
    fo <- findOverlaps(bsgr[[1]], regionsGR)
    
    setkey(BSDT, chr, start)
    # Gut check:
    # stopifnot(all(elementMetadata(bsgr[[1]])$coverage == BSDT$coverage))
    
    # message("Setting regionIDs...");
    BSDT <- BSDT[queryHits(fo), ] # restrict the table to CpGs in any region.
    
    if (NROW(BSDT) < 1) {
        # warning("No BSDT sites in the given region list. 
        #         Please expand your regionsGRL")
        return(NULL)
    }
    
    BSDT[, regionID := subjectHits(fo)] # record which region they overlapped.
    # if (!keep.na) {
    # BSDT <- BSDT[queryHits(fo), ]
    #}
    
    if (is.null(jCommand)) {
        cols <- c(sumCols, keepCols)
        funcs <- c(rep("sum", length(sumCols)), rep("unique", length(keepCols)))
        jCommand <- buildJ(cols, funcs)
    }
    # message("jCommand: ", jCommand)
    
    # Build the by string
    if (is.null(splitFactor)) {
        byString <- paste0("list(regionID)");
    } else {
        byString <- paste0("list(", paste("regionID", paste0(splitFactor, ""), 
                                         collapse = ",", sep = ","), ")")
    }
    
    # Now actually do the aggregate:
    # message("Combining...");
    # for MIRA: average methylProp and sum coverage within each instance of 
    # each bin (ie average methylProp's in bin1 of first region, average 
    # methylProp's in bin1 of second region etc. for all bins and all regions
    # separately)
    bsCombined <- BSDT[, eval(parse(text = jCommand)), 
                      by = eval(parse(text = byString))]
    setkey(bsCombined, regionID)
    # Now aggregate across groups.
    # I do this in 2 steps to avoid assigning regions to groups, 
    # which takes awhile. I think this preserves memory and is faster.
    
    # Define aggregation column. aggregate by region or by region group?
    if (byRegionGroup) {
        # must set allow = TRUE here in case there are multiple IDs (splitCol)
        # adds regionGroupID column from region2group to bsCombined
        bsCombined[region2group, regionGroupID := regionGroupID, allow = TRUE]
        if (! is.null(splitFactor)) { 
            byStringGroup <- paste0("list(", 
                                   paste("regionGroupID", 
                                         paste0(splitFactor, collapse = ","), 
                                         sep = ","), 
                                   ")")
        } else {
            byStringGroup <- "list(regionGroupID)"
        }
       
        
        # actual aggregation operation
        # for normal MIRA use: averaging methylProp's and summing
        # coverage for all bins with the same number (ie all
        # bin1's together, all bin2's together, etc.)
        # NOTE: 2nd use of the jCommand so if the first jCommand use changed
        # column names that are required by the jCommand 
        # then this 2nd jCommand use will cause an error
        bsCombined <- bsCombined[, eval(parse(text = jCommand)), 
                                by = eval(parse(text = byStringGroup))]
        
        # if any strand information was not given, averaging the profiles 
        # about the center to account for unknown strand orientation, 
        # also averaging coverage about center
        # ie if any "*" are present then average
        if ("*" %in% unique(as.character(strand(regionsGR)))) {
            bsCombined[, methylProp := (methylProp + rev(methylProp)) / 2]
            if (hasCoverage) {
                bsCombined[, coverage := (coverage + rev(coverage)) / 2]
            }
        }
        
        # changing "regionGroupID" name to "bin" which is less confusing
        # for normal MIRA use cases
        setnames(bsCombined, old = "regionGroupID", new = "bin")
        return(bsCombined[]);
    } else {
        warning(cleanws("Using byRegionGroup = FALSE may 
             result in missing functionalities such as symmetrical averaging"))
        e <- region2group[bsCombined, ]
        setkey(e, regionID);
        return(e);
    }
    # WARNING: There are now 2^2 ways to aggregate, sum vs mean
    # at each level: across regions, then across region sets. THis
    # doesn't give you a choice at this point. 
}



#' Divide region into similarly sized bins.
#'
#' Given a start, end, and number of bins, to divide, 
#' this function will split the regions into bins.
#' Bins will be only approximately the same size, due to rounding.
#' (they should not be more than 1 different).
#'
#' Use case: take a set of regions, like CG islands, and bin them; now you can
#' aggregate signal scores across the bins, giving you an aggregate signal
#' in bins across many regions of the same type.
#'
#' In theory, this just runs on 3 values, but you can run it inside a 
#' data.table j expression to divide a bunch of regions in the same way.
#' @param start Coordinate for beginning of range/range.
#' @param end Coordinate for end of range/region.
#' @param bins How many bins to divide this range/region.
#' @param idDF A string/vector of strings that has chromosome (e.g. "chr1") 
#' for given start and end values
#' @param strand "strand" column of the data.table (or single
#' strand value if binRegion is only used on one region). Default is "*".
#'
#' @return
#' A data.table, expanded to nrow = number of bins, with these id columns:
#'      id: region ID
#'      binID: repeating ID (this is the value to aggregate across)
#'      ubinID: unique bin IDs
#' @export
#' @examples
#' library(data.table)
#' start <- c(100, 1000, 3000)
#' end <- c(500, 1400, 3400)
#' chr <- c("chr1", "chr1", "chr2")
#' strand <- c("*", "*", "*")
#' # strand not included in object 
#' # since MIRA assumes "*" already unless given something else
#' regionsToBinDT <- data.table(chr, start, end)
#' numberOfBins <- 15
#' # data.table "j command" using column names and numberOfBins variable
#' binnedRegionDT <- regionsToBinDT[, binRegion(start, end, numberOfBins, chr)]
binRegion <- function(start, end, bins, idDF = NULL, strand = "*") {
    # if (!is.null(idDF) & (!is(idDF, "data.frame"))) {
    #   stop("idDF should be a data.frame")
    #}
    
    # conditionally altered later
    finalColNames <- c("chr", "start", "end", "id", "binID", "ubinID")
    if (!("*" %in% strand)) {
        if ("+" %in% strand) {
            plusIndex <- which(strand == "+")
            # once for plus strand coordinates
            plusStart <- start[plusIndex]
            plusEnd <- end[plusIndex]
            
            binSize <- (plusEnd - plusStart) / (bins)
            breaks <- round(rep(plusStart, each = (bins + 1)) 
                           + (0:(bins)) * rep(binSize, each = (bins + 1)))
            
            endpoints <- (bins + 1) * (1:(length(plusStart)))
            startpoints <- 1 + (bins + 1)  * (0:(length(plusStart) - 1))
            
            plusDT <- data.table(start = breaks[-endpoints], 
                                end = breaks[-startpoints], 
                                id = rep(plusIndex, each = bins), 
                                binID = 1:bins, 
                                strand = "+", 
                                key = "id")
            dt <- plusDT # placeholder but may be returned
        }
        if ("-" %in% strand) {
            minusIndex <- which(strand == "-")
            
            minusStart <- start[minusIndex]
            minusEnd <- end[minusIndex]
            
            binSize <- (minusEnd - minusStart) / (bins)
            breaks <- round(rep(minusStart, each = (bins + 1)) 
                           + (0:(bins)) * rep(binSize, each = (bins + 1)))
            
            endpoints <- (bins + 1) * (1:(length(minusStart)))
            startpoints <- 1 + (bins + 1)  * (0:(length(minusStart) - 1))
            
            minusDT <- data.table(start = breaks[-endpoints], 
                                 end = breaks[-startpoints], 
                                 id = rep(minusIndex, each = bins), 
                                 binID = bins:1, 
                                 strand = "-", 
                                 key = "id")
            dt <- minusDT # placeholder but may be returned
        }
        
        # if there are both + and - strands
        # combining and sorting plus and minus data.tables 
        if (("+" %in% strand) && ("-" %in% strand)) {
            dt <- rbindlist(list(plusDT, minusDT))
            setorder(x = dt, id, binID)  # setorder(dt, id) might also work?
        }
        
        # included only if + /- are present
        finalColNames <- c(finalColNames, "strand")
        dt[, ubinID := 1:nrow(dt)] 
        
    }else { # some strand information is "*", don't flip bin directions
        
        binSize <- (end - start) / (bins)
        breaks <- round(rep(start, each = (bins + 1)) 
                       + (0:(bins)) * rep(binSize, each = (bins + 1)))
        
        endpoints <- (bins + 1) * (1:(length(start)))
        startpoints <- 1 + (bins + 1)  * (0:(length(start) - 1))
        # do all regions in the same order
        dt <- data.table(start = breaks[-endpoints], 
                        end = breaks[-startpoints], 
                        id = rep((seq_along(start)), each = bins), 
                        binID = 1:bins, 
                        ubinID = seq_along(breaks[-startpoints]), 
                        key = "id")
        
    }
    
    if (!is.null(idDF)) {
        chr <- rep(idDF, each = bins)
        dt <- dt[, chr := chr]
        setcolorder(dt, finalColNames)  # putting chr first, does not copy
    }
    
    return(dt[])
}

## ----eval=TRUE, message=FALSE, warning=FALSE----------------------------------
library(MIRA)
library(data.table) # for the functions: fread, setkey, merge
library(GenomicRanges) # for the functions: GRanges, resize
library(ggplot2) # for the function: ylab
exampleAnnoDT2 <- fread(system.file("extdata", "exampleAnnoDT2.txt", 
                                   package="MIRA")) 

## ----eval=FALSE---------------------------------------------------------------
# # 12 Ewing samples: T1-T12
# pathToData <- "/path/to/MIRA_Ewing_Vignette_Files/"
# ewingFiles <- paste0(pathToData, "EWS_T", 1:12, ".bed")
# # 12 muscle related samples, 3 of each type
# muscleFiles <- c("Hsmm_", "Hsmmt_", "Hsmmfshd_","Hsmmtubefshd_")
# muscleFiles <- paste0(pathToData, muscleFiles, rep(1:3, each=4), ".bed")
# RRBSFiles <- c(ewingFiles, muscleFiles)
# regionSetFiles <- paste0(pathToData, c("sknmc_specific.bed", "muscle_specific.bed"))

## ----eval=FALSE---------------------------------------------------------------
# BSDTList <- lapply(X=RRBSFiles, FUN=BSreadBiSeq)
# regionSets <- lapply(X=regionSetFiles, FUN=fread)

## ----eval=FALSE---------------------------------------------------------------
# names(BSDTList) <- tools::file_path_sans_ext(basename(RRBSFiles))
# regionSets <- lapply(X=regionSets,
#                     FUN=function(x) setNames(x, c("chr", "start", "end")))
# regionSets <- lapply(X=regionSets, FUN=
#                         function(x) GRanges(seqnames=x$chr,
#                                               ranges=IRanges(x$start, x$end)))

## ----eval=FALSE---------------------------------------------------------------
# regionSets[[1]] <- resize(regionSets[[1]], 5000, fix="center")
# regionSets[[2]] <- resize(regionSets[[2]], 5000, fix="center")
# names(regionSets) <- c("Ewing_Specific", "Muscle_Specific")

## ----eval=FALSE---------------------------------------------------------------
# subBSDTList <- BSDTList[c(1, 5, 9, 13, 17, 21)]
# bigBin <- lapply(X=subBSDTList, FUN=aggregateMethyl, GRList=regionSets,
#                 binNum=21, minBaseCovPerBin=0)

## ----eval=FALSE---------------------------------------------------------------
# bigBinDT1 <- rbindNamedList(bigBin, newColName = "sampleName")

## ----eval=TRUE----------------------------------------------------------------
# from data included with MIRA package
data(bigBinDT1)

## ----eval=TRUE----------------------------------------------------------------
setkey(exampleAnnoDT2, sampleName)
setkey(bigBinDT1, sampleName)
bigBinDT1 <- merge(bigBinDT1, exampleAnnoDT2, all.x=TRUE)

## ----eval=TRUE----------------------------------------------------------------
plotMIRAProfiles(binnedRegDT=bigBinDT1)

## ----eval=FALSE---------------------------------------------------------------
# regionSets[[1]] <- resize(regionSets[[1]], 4000, fix="center") # Ewing
# regionSets[[2]] <- resize(regionSets[[2]], 1750, fix="center") # muscle

## ----eval=FALSE---------------------------------------------------------------
# bigBin <- lapply(X=BSDTList, FUN=aggregateMethyl, GRList=regionSets,
#                 binNum=21, minBaseCovPerBin=0)
# bigBinDT2 <- rbindNamedList(bigBin)

## ----eval=TRUE----------------------------------------------------------------
# from data included with MIRA package
data(bigBinDT2)

## ----eval=TRUE----------------------------------------------------------------
# data.table functions are used to add info from annotation object to bigBinDT2
setkey(exampleAnnoDT2, sampleName)
setkey(bigBinDT2, sampleName)
bigBinDT2 <- merge(bigBinDT2, exampleAnnoDT2, all.x=TRUE)

## ----eval=TRUE----------------------------------------------------------------
plotMIRAProfiles(binnedRegDT=bigBinDT2)

## ----eval=TRUE, results="hide"------------------------------------------------
bigBinDT2[, methylProp := methylProp - min(methylProp) + .05, by=.(featureID, sampleName)]

## ----eval=TRUE----------------------------------------------------------------
normPlot <- plotMIRAProfiles(binnedRegDT=bigBinDT2)
normPlot + ylab("Normalized DNA Methylation (%)")

## ----eval=TRUE----------------------------------------------------------------
sampleScores <- calcMIRAScore(bigBinDT2,
                        shoulderShift="auto",
                        regionSetIDColName="featureID",
                        sampleIDColName="sampleName")
head(sampleScores)

## ----eval=TRUE----------------------------------------------------------------
setkey(exampleAnnoDT2, sampleName)
setkey(sampleScores, sampleName)
sampleScores <- merge(sampleScores, exampleAnnoDT2, all.x=TRUE)
plotMIRAScores(sampleScores)

## -----------------------------------------------------------------------------
EwingSampleEwingRegions <- sampleScores[sampleScores$sampleType == "Ewing" &
                                           sampleScores$featureID ==
                                           "Ewing_Specific", ]
myoSampleEwingRegions <- sampleScores[sampleScores$sampleType == "Muscle-related" &
                                           sampleScores$featureID ==
                                           "Ewing_Specific", ]
wilcox.test(EwingSampleEwingRegions$score, myoSampleEwingRegions$score)

## -----------------------------------------------------------------------------
EwingSampleMyoRegions <- sampleScores[sampleScores$sampleType == "Ewing" &
                                           sampleScores$featureID ==
                                           "Muscle_Specific", ]
myoSampleMyoRegions <- sampleScores[sampleScores$sampleType == "Muscle-related" &
                                           sampleScores$featureID ==
                                           "Muscle_Specific", ]
wilcox.test(EwingSampleMyoRegions$score, myoSampleMyoRegions$score)

# Plotting functions to visualize outputs of MIRA
# Visualize MIRA profiles and MIRA scores




#' Plot summary methylation profile
#' 
#' Plot one or multiple methylation profiles. Displays each region set
#' in a different subplot.
#' If you only want to plot certain region sets,
#' subset with the `featID` parameter.
#' 
#' @param binnedRegDT A datatable with specific column names containing:
#' bin numbers(binnedRegionDT column), 
#' aggregated methylation values (methylProp column), 
#' name of the region set (featureID column), 
#' case/control column (sampleType column), 
#' sample name (sampleName column).
#' @param featID Region set names in a single string or vector of strings.
#' @param plotType Line or jitter (ggplot2). 
#' @param colBlindOption If TRUE, function will plot with a color blind
#' friendly palette which could be helpful when plotting multiple colors.
#' @param sampleTypeColName character object. The name of the column that
#' contains sample type or condition information (eg case vs control).
#' Line color will be assigned based on this if it is present and there are
#' more than two unique sample types.
#' 
#' @return A plot of class "gg"/ "ggplot" that shows MIRA profiles
#' @examples
#' data("exampleBins", package = "MIRA")
#' MIRAplot <- plotMIRAProfiles(binnedRegDT = exampleBins)
#' 
#' @export
plotMIRAProfiles <- function(binnedRegDT, 
                            featID = unique(binnedRegDT[, featureID]), 
                            plotType = "line",
                            colBlindOption = FALSE,
                            sampleTypeColName="sampleType"){
    binNum <- max(binnedRegDT[, bin])
    setkey(binnedRegDT, featureID)
    binPlot <- ggplot(data = binnedRegDT[featID], 
                     mapping = aes(x = factor(bin), 
                                   y = methylProp * 100)) +
                    theme_classic() + ylim(c(0, 100)) +
                    geom_hline(yintercept=c(0), alpha=.2) +
                    ylab("DNA Methylation (%)") + 
                    xlab("Genome Regions Surrounding Sites") +
                    scale_x_discrete(labels=xAxisForRegionPlots(binNum))
    if (colBlindOption) {
        binPlot <- binPlot + scale_color_brewer(name = "Sample Type", 
                                           palette = "Dark2")
    } else {
        binPlot <- binPlot + scale_color_brewer(name = "Sample Type", 
                                               palette = "Set1")
    }
        
    
    if (!(sampleTypeColName %in% names(binnedRegDT))) {
        # if no sampleType column then all lines/points will be black
        warning(cleanws("If you want to split up sample types by 
                        color use sampleTypeColName parameter."))
        
        # no color given if no sampleType
        if (plotType == "line") {
            binPlot <- binPlot + 
                geom_line(aes(group = sampleName)) + 
                facet_wrap(~featureID)
        } else if (plotType == "jitter") {
            binPlot <- binPlot + geom_jitter(alpha = .4) + 
                facet_wrap(~featureID)
        } else {
            stop('The only supported values for plotType are "line" and "jitter"')
        }
    } else {
        if (plotType == "line") {
            binPlot <- binPlot + 
                geom_line(aes(col = get(sampleTypeColName), group = sampleName)) + 
                facet_wrap(~featureID)
        } else if (plotType == "jitter") {
            binPlot <- binPlot + geom_jitter(aes(col = get(sampleTypeColName)), alpha = .4) + 
                facet_wrap(~featureID)
        } else {
            stop('The only supported values for plotType are "line" and "jitter"')
        }   
    }
    
    return(binPlot)
}

# A function to get right x axis numbers on the plotMIRAProfiles() plots
xAxisForRegionPlots <- function(binNum) {
    if ((binNum %% 2) == 0) { # even binNum
        tmp <- c((-1 * binNum / 2):-1, 1:(binNum / 2)) # no zero
        xAxis <- c(tmp[1], rep("", (binNum - 4) / 2), -1, 1, 
                  rep("", (binNum - 4) / 2), tmp[binNum])
    } else if ((binNum %% 2) == 1) { # odd binNum
        tmp <- (-1 * (binNum - 1) / 2):((binNum - 1) / 2)
        xAxis <- c(tmp[1], rep("", (binNum - 3) / 2), 0, 
                  rep("", (binNum - 3) / 2), tmp[binNum])
    }
    return(xAxis)
}

#' Plot MIRA scores and compare different conditions
#' 
#' Splits up samples by sample type. Displays each region set
#' in a different subplot.
#' If you only want to plot certain region sets,
#' subset with the `featID` parameter. 
#' 
#' Due to the limited number
#' of colors in the palette, a warning will be issued if 
#' there are too many (more than 9) region sets ('featureID's).
#' 
#' @param scoreDT A datatable with the following columns: 
#' score, featureID (names of region sets), ideally include 'sampleType'.
#' @param featID Region set name/names in a single string or vector of strings.
#' @param colBlindOption If TRUE, function will plot with a color blind
#' friendly palette which could be helpful when plotting multiple colors. 
#' @return a plot of class "gg"/"ggplot" that shows MIRA scores 
#' with geom_boxplot and geom_jitter (or geom_violin instead
#' of boxplot if no sampleType column is given).
#' @export
#' @examples
#' data(bigBinDT2)
#' exScores <- calcMIRAScore(bigBinDT2)
#' # adding annotation
#' sampleType <- rep(c("Ewing", "Muscle-related"), each = 24)
#' exScores <- cbind(exScores, sampleType)
#' exScorePlot <- plotMIRAScores(exScores)         
plotMIRAScores <- function(scoreDT, 
                           featID = unique(scoreDT[, featureID]),
                           colBlindOption = FALSE){
    # the preferred option when 'sampleType' is a column
    if ("sampleType" %in% colnames(scoreDT)) {
        sampleTypeNum <- length(unique(scoreDT[, sampleType]))
        setkey(scoreDT, featureID)
        scorePlot <- ggplot(data = scoreDT[featID], 
                           mapping = aes(x = sampleType, 
                                         y = score, 
                                         col = sampleType)) + 
            theme_classic() +
            ylab("MIRA Score") + xlab("Sample Type") +
            geom_boxplot(aes(fill = sampleType), alpha = 0.75) + 
            geom_jitter(data = scoreDT[featID], 
                        mapping = aes(x = sampleType, y = score)) + 
            scale_color_manual(guide = FALSE, values = rep("black", 
                                                           sampleTypeNum)) +
            facet_wrap(~featureID)
        if (colBlindOption) {
            scorePlot <- scorePlot + scale_fill_brewer(name = "Sample Type", 
                                                      palette="Dark2")
        } else {
            scorePlot <- scorePlot + scale_fill_brewer(name = "Sample Type", 
                                                      palette="Set1")
        }
        
    } else {
        # a less fancy plot when sampleType column is not present
        setkey(scoreDT, featureID)
        scorePlot <- ggplot(data = scoreDT[featID], 
                           mapping = aes(x = "", y = score, 
                                         col = featureID)) + 
            theme_classic() +
            theme(axis.title.x = element_blank(),
                  axis.ticks.x = element_blank()) +
            ylab("MIRA Score") + # xlab("") +
            geom_violin(aes(fill = featureID), alpha = 0.75) +
            geom_jitter() +
            scale_color_manual(guide = FALSE, 
                               values = rep("black", length(featID))) +
            facet_wrap(~featureID)
        if (colBlindOption) {
            scorePlot <- scorePlot + scale_fill_brewer(name = "Region Set", 
                                                      palette="Dark2")
        } else {
            scorePlot <- scorePlot + scale_fill_brewer(name = "Region Set", 
                                                      palette="Set1")
        }
        
    }
        
    return(scorePlot)
}

#' A data.table containing DNA methylation data.
#' 
#' This object contains reduced
#' representation bisulfite sequencing data from the
#' GM06990 B-lymphoblastoid cell line that was generated by the ENCODE
#' project (GEO accession GSE27584, sample GSM980583). Has columns for
#' position (chr, start), number methylated reads, and number of reads total.
#' The sample name is Gm06990_1.
#' Only a subset of the full data is used in this object and the 
#' data was switched from hg19 to hg38.
#'
#'
#' @docType data
#' @keywords datasets
#' @name exampleBSDT
#' @usage data(exampleBSDT)
#' @format A data.table, data.frame object
NULL

#' A Granges object with Nrf1-binding regions.
#' 
#' A GRanges object with a ranges corresponding to Nrf1 Chip-seq peaks
#' in the GM12878 B-lymphoblastoid cell line (GEO accession GSE31477, 
#' sample GSM935309). Only a subset of the ranges are used in 
#' this object and the regions were switched from hg19 to hg38.
#'
#'
#' @docType data
#' @keywords datasets
#' @name exampleRegionSet
#' @usage data(exampleRegionSet)
#' @format A GRanges object
NULL

#' A data.table with annotation for a bisulfite sample.
#' 
#' Has columns for name and sample type. 
#'
#'
#' @docType data
#' @keywords datasets
#' @name exampleAnnoDT1
#' @usage data(exampleAnnoDT1)
#' @format A data.table, data.frame object
NULL

#' A data.table with artificial binned methylation data
#'
#' Artificial data for two samples/conditions.
#'
#' @docType data
#' @keywords datasets
#' @name exampleBins
#' @usage data(exampleBins)
#' @format A data.table, data.frame object
NULL

#' DNA methylation data for the "Applying MIRA to a Biological Question"
#' vignette (1st part).
#' 
#' A data.table with binned methylation data for the first part of
#' the "Applying MIRA to a Biological Question" vignette. 
#' Has data for 3 Ewing samples and 3 muscle-related 
#' samples (human skeletal myoblasts and other related
#' samples). It is the product of `aggregateMethyl`.
#'
#'
#' @docType data
#' @keywords datasets
#' @name bigBinDT1
#' @usage data(bigBinDT1)
#' @format A data.table, data.frame object
NULL

#' DNA methylation data for the "Applying MIRA to a Biological Question" 
#' vignette (2nd part).
#' 
#' A data.table with binned methylation data for the second part
#' of the "Applying MIRA to a Biological Question" vignette. 
#' Has data for 12 Ewing samples and 12 muscle-related samples 
#' (human skeletal myoblasts and other related
#' samples). It is the product of `aggregateMethyl`.
#'
#'
#' @docType data
#' @keywords datasets
#' @name bigBinDT2
#' @usage data(bigBinDT2)
#' @format A data.table, data.frame object
NULL

#' Annotation data for the "Applying MIRA to a 
#' Biological Question" vignette. 
#' 
#' A data.table with annotation data (sampleName
#' and sampleType columns) for 24 Ewing samples and 24 muscle-related
#' samples (human skeletal myoblasts and other related samples).
#'
#'
#' @docType data
#' @keywords datasets
#' @name exampleAnnoDT2
#' @usage data(exampleAnnoDT2)
#' @format A data.table, data.frame object
NULL

#' A small BSseq object.
#' 
#' A BSseq object which has the top 20 rows of the BSseq object "BS.chr22"
#' which was included as built-in data in the bsseq package
#' 
#' 
#' @docType data
#' @keywords datasets
#' @name exampleBSseqObj
#' @usage data(exampleBSseqObj)
#' @format A BSseq object
NULL

#########################################################
# Utility functions
# Conversion functions in 2nd half of file
########################################################


# This function is a drop-in replacement for the base list() function, 
# which automatically names your list according to the names of the 
# variables used to construct it.
# It seamlessly handles lists with some names and others absent, 
# not overwriting specified names while naming any unnamed parameters.
#
# @param ...   arguments passed to list()
# @return A named list object.
# @examples
# x <- 5
# y <- 10
# nlist(x, y) # returns list(x = 5, y = 10)
# list(x, y) # returns unnamed list(5, 10)
nlist <- function(...) {
    fcall <- match.call(expand.dots = FALSE)
    l <- list(...);
    if (!is.null(names(list(...)))) { 
        names(l)[names(l) == ""] <- fcall[[2]][names(l) == ""]
    } else {  
        names(l) <- fcall[[2]];
    }
    return(l)
}



# Function to run lapply or mclapply, depending on the option set in
# getOption("mc.cores"), which can be set with setLapplyAlias().
#
# @param ... Arguments passed lapply() or mclapply()
# @param mc.preschedule Argument passed to mclapply
# @return Result from lapply or parallel::mclapply
lapplyAlias <- function(..., mc.preschedule = TRUE) {
    if (is.null(getOption("mc.cores"))) { setLapplyAlias(1) }
    if (getOption("mc.cores") > 1) {
        return(parallel::mclapply(..., mc.preschedule = mc.preschedule))
    } else {
        return(lapply(...))
    }
}



# To make parallel processing a possibility but not required, 
# I use an lapply alias which can point at either the base lapply
# (for no multicore), or it can point to mclapply, 
# and set the options for the number of cores (what mclapply uses).
# With no argument given, returns intead the number of cpus currently selected.
#
# @param cores Number of cpus
# @return None
setLapplyAlias <- function(cores = 0) {
    if (cores < 1) {
        return(getOption("mc.cores"))
    }
    if (cores > 1) { # use multicore?
        if (requireNamespace("parallel", quietly = TRUE)) {
            options(mc.cores = cores)
        } else {
            warning(cleanws("You don't have package parallel installed. 
                    Setting cores to 1."))
            options(mc.cores = 1) # reset cores option.
        }
    } else {
        options(mc.cores = 1) # reset cores option.
    }
}



# helper function
# given a vector of columns, and the equally-sized vector of functions
# to apply to those columns, constructs a j-expression for use in
# a data.table 
# (functions applied to columns in corresponding spot in "cols" string).
# One function may be given to be applied to multiple columns.
# use it in a DT[, eval(parse(text = buildJ(cols, funcs)))]
# @param cols A string/vector of strings containing columns 
# on which to use functions.
# @param funcs Functions to use on columns.
# @return A jcommand string. After performing function on column, column 
# is reassigned the same name.
buildJ <- function(cols, funcs, newColNames=NULL) {
    if (is.null(newColNames)) {
        # previously the only option (changed 10/16/17)
        r <- paste("list(", paste(paste0(cols, "=", funcs, "(", cols, ")"), collapse = ","), ")")
    } else {
        r <- paste("list(", paste(paste0(newColNames, "=", funcs, "(", cols, ")"), collapse = ","), ")")
    }
    return(r);
}

# cleanws takes multi-line, code formatted strings and just formats them
# as simple strings
# @param string string to clean
# @return A string with all consecutive whitespace characters, including
# tabs and newlines, merged into a single space.
cleanws <- function(string) {
    return(gsub('\\s+'," ", string))
}
#' Combine data.tables from a named list into one big data.table with extra
#' column for name.
#' 
#' Combines data.tables from a list as data.table::rbindlist except an 
#' extra column is added which can mark which rows came from which 
#' original data.table. The name of this new column can be 
#' specified (newColName param) and the values are the names of the input list.
#' This function was originally intended for a list where each
#' data.table corresponds to a separate sample and the list names
#' correspond to the names of the samples. Now all samples can
#' be combined into one data.table but which sample the information
#' came from can be kept.
#' 
#' @param namedList A list of data.tables. One sample per data.table/list item.
#' Names of the list are the sample names. 
#' @param newColName The name of the column that will be added to the data.tables
#' 
#' @return mergedDT A single data.table that combines those in the input list 
#' (data.table::rbindlist)
#' but also added a column (default, newColName="sampleName") to each one to
#' keep track of which rows were from which sample
#' @examples 
#' # NOTE: generally sample names should be added after running aggregateMethyl() 
#' # rather than before in order to save memory (since data.table has less rows
#' # after aggregation)
#' data(exampleBSseqObj)
#' multiSampleList <- bsseqToDataTable(exampleBSseqObj)
#' combinedDT <- rbindNamedList(multiSampleList)
#' @export
rbindNamedList <- function(namedList, newColName="sampleName") {
    # making a copy so original object will not be changed by reference
    namedListC <- data.table::copy(namedList)
    
    newColVals <- names(namedListC)
    # if a not all items in list are named
    if (length(newColVals) < length(namedListC)) {
        warning("All list items should be named.")
    }
    
    # named it .y just in case someone made their new column name (newColName) y
    # after testing I don't think that actually is a problem but I'll keep it
    jExpr <- paste0(newColName, " := .y")
    # by reference
    mapply(FUN = function(x, .y) x[, eval(parse(text = jExpr))], namedListC, newColVals)
    mergedDT <- rbindlist(namedListC, fill = TRUE)
    
    return(mergedDT)
}


####################  Conversion Functions  ########################
# Convert between different object types

# Convert a data.table to GRanges object.
# 
# @param DT a data.table with at least "chr" and "start" columns
# 
# @return gr A genomic ranges object derived from DT
dtToGr <- function(DT, chr = "chr", start = "start", 
                  end = NA, strand = NA, name = NA, 
                  splitFactor = NA, metaCols = NA) {
    
    if (is.na(splitFactor)) {
        return(dtToGrInternal(DT, chr, start, end, strand, name, metaCols));
    }
    if ( length(splitFactor) == 1 ) { 
        if (splitFactor %in% colnames(DT)) {
            splitFactor <- DT[, get(splitFactor)];
        }
    }
    lapply(split(1:nrow(DT), splitFactor), 
           function(x) { 
               dtToGrInternal(DT[x, ], chr, start, end, strand, name, metaCols)
           }
    )
}

dtToGR <- dtToGr;


# Internal part of a utility to convert data.tables into GRanges objects
# 
# @param DT A data.table with at least "chr" and "start" columns
# @return gr A genomic ranges object derived from DT
dtToGrInternal <- function(DT, chr, start, 
                          end = NA, strand = NA, name = NA, metaCols = NA) {
    
    if (is.na(end)) {
        if ("end" %in% colnames(DT)) {
            end <- "end"
        } else {
            end <- start;
        }
    }
    if (is.na(strand)) {
        if ("strand" %in% colnames(DT)) { # checking if strand info is in DT
            strand <- "strand"
        }
    }
    if (is.na(strand)) {
        gr <- GRanges(seqnames = DT[[`chr`]], 
                     ranges = IRanges(start = DT[[`start`]], end = DT[[`end`]]), 
                     strand = "*")
    } else {
        # GRanges can only handle '*' for no strand, so replace any non-accepted
        # characters with '*'
        DT[, strand := as.character(strand)]
        DT[strand == "1", strand := "+"]
        DT[strand == "-1", strand := "-"]
        DT[[`strand`]] <- gsub("[^+-]", "*", DT[[`strand`]])
        gr <- GRanges(seqnames = DT[[`chr`]], 
                     ranges = IRanges(start = DT[[`start`]], end = DT[[`end`]]), 
                     strand = DT[[`strand`]])
    }
    if (! is.na(name)) {
        names(gr) <- DT[[`name`]];
    } else {
        names(gr) <- seq_along(gr);
    }
    if (! is.na(metaCols)) {
        for(x in metaCols) {
            elementMetadata(gr)[[`x`]] <- DT[[`x`]]
        }
    }
    gr;
}



# Converts a list of data.tables into GRanges.
# @param dtList A list of data.tables, 
# Each should have "chr", "start", "methylCount", and "coverage" columns.
# Error results if missing "chr", "start" but if methylCount and coverage are
# missing, it will still work, just not have that info in the output.
# @return a list of GRanges objects, strand has been set to "*", 
# "start" and "end" have both been set to "start" of the DT.
# methylCount and coverage info is not included in GRanges object.
BSdtToGRanges <- function(dtList) {
    
    gList <- list();
    for (i in seq_along(dtList)) {
        # dt <- dtList[[i]];
        setkey(dtList[[i]], chr, start)
        # convert the data into granges object
            gList[[i]] <- GRanges(seqnames = dtList[[i]]$chr, 
                                 ranges = IRanges(start = dtList[[i]]$start, 
                                                  end = dtList[[i]]$start), 
                                 strand = rep("*", nrow(dtList[[i]])))
        
        # I used to use end = start + 1, but this targets CG instead of just 
        # a C, and it's causing edge-effects problems when I assign Cs to 
        # tiled windows using (within). Aug 2014 I'm changing to start/end at 
        # the same coordinate.
    }
    return(gList);
}



# Convert a GenomicRanges into a data.table
#
# Also can convert GPos objects to a data.table.
# 
# @param GR A GRanges object
# @param includeStrand Boolean, whether to include strand from GR in output DT
# @return A data.table object with columns:
# "chr", "start", and "end" (possibly strand)
grToDt <- function(GR, includeStrand = FALSE) {
    DF <- as.data.frame(elementMetadata(GR))
    if ( ncol(DF) > 0) {
        if (includeStrand) {
            DT <- data.table(chr = as.vector(seqnames(GR)), 
                            start = start(GR), 
                            end = end(GR), 
                            strand = as.vector(strand(GR), mode = "character"), 
                            DF)    
        } else{
            DT <- data.table(chr = as.vector(seqnames(GR)), 
                            start = start(GR), 
                            end = end(GR), 
                            DF)    
        }
    } else {
        if (includeStrand) {
            DT <- data.table(chr = as.vector(seqnames(GR)), 
                            start = start(GR), 
                            end = end(GR), 
                            strand = as.vector(strand(GR), mode = "character")) 
        } else{
            DT <- data.table(chr = as.vector(seqnames(GR)), 
                            start = start(GR), 
                            end = end(GR))    
        }
    }
    return(DT)
}





#' Make MIRA-compatible data.tables using information 
#' from SummarizedExperiment-based classes
#' 
#' Packages that use SummarizedExperiment-based classes for DNA methylation
#' data which could be converted with this function 
#' include "bsseq", "methylPipe", and "BiSeq" packages. 
#' Of the methylCountDF, coverageDF, and methylPropDF arguments, either 
#' methylPropDF must be given or both methylCountDF and coverageDF must
#' be given. After that, whichever is not given will be calculated 
#' from the others. If coverageDF and methylCountDF are both not given,
#' coverage will be assumed to be 1 at each site with a methylProp value.
#' Acceptable formats for the three "DF" parameters include:
#' data.frame, data.table, matrix, and DelayedMatrix classes.
#' If converting a BSseq object, see ?bsseqToDataTable for a convenient
#' wrapper of this function.
#' 
#' @param coordinates Coordinates for the methylation loci as a GRanges 
#' (or GPos) object (in same order as methylCountDF/coverageDF/methylPropDF, 
#' whichever is given).
#' The start coordinate should be the coordinate of the cytosine.
#' @param methylCountDF An object of matrix/data.frame/similar format
#' that contains the number of reads with methylated C's for the loci in
#' 'coordinates' argument. It should have one column per sample with
#' rows that correspond to 'coordinates'.
#' @param coverageDF An object of matrix/data.frame/similar format
#' that contains the total number of reads for the loci in
#' 'coordinates' argument. It should have one column per sample with
#' rows that correspond to 'coordinates'.
#' @param methylPropDF An object of matrix/data.frame/similar format
#' that contains the total number of reads for the loci in
#' 'coordinates' argument. It should have one column per sample with
#' rows that correspond to 'coordinates'.
#' @param sample_names A character vector with sample names in the same
#' order as the columns of methylCountDF/coverageDF/methylPropDF
#' samples in the columns
#' @return MIRAFormatBSDTList A list of data.tables containing
#' the methylation data. One data.table per sample with the column
#' names: 'chr', 'start' (methylation coordinate), 'methylCount' (number of
#' methylated reads), 'coverage' (total number of reads), and 
#' 'methylProp' (proportion of methylated reads). The order of the
#' list is the order of samples in the columns of 
#' methylCountDF/coverageDF/methylPropDF. If sample names 
#' are explicitly given as input ('sample_names' argument)
#' or can be derived from other arguments to the function then
#' a named list will be returned. 
#' @examples  
#' data("exampleBSseqObj")
#' MIRAFormatBSDTList <- SummarizedExperimentToDataTable(coordinates = 
#'     bsseq::granges(exampleBSseqObj), 
#'     methylCountDF = bsseq::getCoverage(BSseq = exampleBSseqObj, type = "M"), 
#'     coverageDF = bsseq::getCoverage(BSseq = exampleBSseqObj, type = "Cov"),
#'     methylPropDF = bsseq::getMeth(BSseq = exampleBSseqObj, type = "raw"),
#'     sample_names = bsseq::sampleNames(exampleBSseqObj))
#' @export
SummarizedExperimentToDataTable <- function(coordinates, methylCountDF=NULL, 
                        coverageDF=NULL, methylPropDF=NULL, 
                        sample_names=NULL) {
    
    haveMCount <- !is.null(methylCountDF)
    haveCov <- !is.null(coverageDF)
    haveMProp <- !is.null(methylPropDF)
    
    # making sure sufficient data has been given
    if (!haveMProp) {
        # if no methylProp given, you need both methylCount and coverage
        if (!haveMCount || !haveCov) {
            stop(cleanws("If methylProp is not given, both 
                         methylCount and coverage must be given."))
        }
        }
    
    # checking that right data types have been given 
    if (!(is(coordinates, "GRanges") || is(coordinates, "GPos"))) {
        stop("'coordinates' argument should be a GRanges or GPos object")
    }
    
    # check for accepted formats?: delayed matrix?, matrix, data.frame, data.table
    # not sure if there might be other valid inputs so excluding this for now
    # if using this code, change to is(object, class) format for if statements
    # if (haveMCount) {
    #     if (!("" %in% class(methylCountDF))) {
    #         stop()
    #     }
    # }
    # if (haveCov) {
    #     if (!("" %in% class(coverageDF))) {
    #         stop()
    #     }
    # }
    # if (haveMProp) {
    #     if (!("" %in% class(methylPropDF))) {
    #         stop()
    #     }
    # }
    
    
    MIRAFormatBSDTList <- list() # to store output
    
    # changing coordinates from GRanges object to data.table
    coordinates <- grToDt(coordinates)
    rowNum <- nrow(coordinates)
    
    # setting sampleNum and doing checks on the inputs
    if (haveMProp) {
        sampleNum <- ncol(methylPropDF)
        # making sure other inputs also have sampleNum columns
        if (haveMCount) {
            if (sampleNum != ncol(methylCountDF)) {
                stop(cleanws("Input with the count of 
                             methylated reads at each loci and input 
                             with the proportion of methylation should have
                             the same number of columns."))
            }
            }
        if (haveCov) {
            if (sampleNum != ncol(coverageDF)) {
                stop(cleanws("Input with the count of total reads at each loci 
                             and input with the proportion of methylation
                             should have the same number of columns."))
            }
            }
            } else {
                sampleNum <- ncol(coverageDF)
                # making sure other input has the same number of columns 
                if (sampleNum != ncol(methylCountDF)) {
                    stop(cleanws("Input with the count of total reads  
                                 and input with the count of methylated reads
                                 at each loci
                                 should have the same number of columns."))
                }
                }
    
    # making sure number of rows are the same in all given inputs
    if (haveMProp) {
        if (rowNum != nrow(methylPropDF)) {
            stop(cleanws("The number of rows for the genomic coordinates and 
                         the number of rows for the proportion of methylation
                         for each loci should be the same."))
        }
        }
    if (haveMCount) {
        if (rowNum != nrow(methylCountDF)) {
            stop(cleanws("The number of rows for the genomic coordinates and 
                         the number of rows for the count of methylated reads
                         for each loci should be the same."))
        }
        }
    if (haveCov) {
        if (rowNum != nrow(coverageDF)) {
            stop(cleanws("The number of rows for the genomic coordinates and 
                         the number of rows for the count of total reads
                         for each loci should be the same."))
        }
        }
    
    # adding sample names if not given as argument but present in other input
    if (is.null(sample_names)) {
        if (haveMProp) {
            sample_names <- colnames(methylPropDF)
        } else {
            sample_names <- colnames(coverageDF)
        }
    }
    
    
    
    if (!haveCov && !haveMCount) {
        coverage <- rep(1, rowNum)
        warning(cleanws("coverage was not included in input 
                        so it was set to 1.
                        It is recommended to set the minBaseCovPerBin 
                        argument of aggregateMethyl to 0."))
    }
    
    # looping through columns/samples to make 1 data.table per sample
    for (i in 1:sampleNum) {
        # each column is a different sample
        # order of the below if statements is important
        if (haveMCount) {
            methylCount <- methylCountDF[, i]
        }
        if (haveMProp) {
            methylProp <- methylPropDF[, i]
        }
        if (haveCov) {
            coverage <- coverageDF[, i]
        } else if (haveMCount) {
            # assumed that if !haveCov, you haveMProp
            coverage <- round(methylCount / methylProp, 3)
        }
        if (haveCov && !haveMCount) {
            # theoretically this should be a whole number
            methylCount <- round(methylProp * coverage, 0)
        }
        
        if (!haveCov && !haveMCount) {
            # this will result in fractional methylCount values (from 0 to 1)
            # but is necessary to be consistent with giving each loci a 
            # coverage of 1 which was done earlier in code 
            # for !haveCov && !haveMCount
            # methylCount = methylProp * coverage = methylProp * 1
            methylCount <- methylProp
        }
        
        if (!haveMProp) {
            methylProp <- round(methylCount / coverage, 3)
        }
        
        # index for taking out rows with 0 coverage
        notCovered <- which(coverage == 0)
        # checking for NAs in methylProp
        # they only should be present if methylPropDF was given
        if (haveMProp) {
            notCoveredNA <- which(is.na(methylProp))
            notCovered <- sort(c(notCovered, notCoveredNA))
        }
        MIRAFormatBSDTList[[i]] <- data.table(chr = coordinates[, chr], 
                                             start = coordinates[, start], 
                                             methylCount = as.vector(methylCount),
                                             coverage = as.vector(coverage),
                                             methylProp = as.vector(methylProp)
        )[!notCovered,] # filtering
        setnames(MIRAFormatBSDTList[[i]], 
                 c("chr", "start", "methylCount", "coverage", "methylProp"))
    }
    
    # add sample names to list (by reference)
    if (!is.null(sample_names)) {
        setattr(MIRAFormatBSDTList, "names", sample_names)
    }
    
    return(MIRAFormatBSDTList)
}

#' Convert a BSseq object to data.table format for MIRA.
#' 
#' Converts a BSseq object to a list of data.tables with one data.table
#' per sample. A wrapper of the SummarizedExperimentToDataTable function.
#' 
#' @param BSseqObj An object of class BSseq, can have smoothed or raw
#' methylation data.
#' @return MIRAFormatBSDTList A list of data.tables containing
#' the methylation data. One data.table per sample with the column
#' names: 'chr', 'start' (methylation coordinate), 'methylCount' (number of
#' methylated reads), 'coverage' (total number of reads), and 
#' 'methylProp' (proportion of methylated reads). The order of the
#' list is the order of samples in the columns of the BSseq object.
#' If sample names are in the BSseq object, then a named list
#' will be returned.
#' @examples 
#' data("exampleBSseqObj")
#' MIRAFormatBSDTList <- bsseqToDataTable(exampleBSseqObj)
#' @export
bsseqToDataTable <- function(BSseqObj) {
    
    if (bsseq::hasBeenSmoothed(BSseqObj)) {
        rawSmooth <- "smooth"
    } else {
        rawSmooth <- "raw"
    }
    
    # use accessor functions from bsseq to get needed data
    MIRAFormatBSDTList <- SummarizedExperimentToDataTable(coordinates = bsseq::granges(BSseqObj), 
                 methylCountDF = getCoverage(BSseq = BSseqObj, type = "M"), 
                 coverageDF = getCoverage(BSseq = BSseqObj, type = "Cov"),
                 methylPropDF = getMeth(BSseq = BSseqObj, type = rawSmooth),
                 sample_names = bsseq::sampleNames(BSseqObj))
    
    # # if only one sample, do not return list, just return data.table
    # if (length(MIRAFormatBSDTList) == 1) {
    #     MIRAFormatBSDTList <- MIRAFormatBSDTList[[1]]
    # }
    
    return(MIRAFormatBSDTList)
}

## ----echo=FALSE, warning=FALSE------------------------------------------------
library(MIRA)
data(exampleBins)
plotMIRAProfiles(exampleBins)
exScores <- calcMIRAScore(exampleBins, 
                    regionSetIDColName="featureID",
                    sampleIDColName="sampleName")
# normally sampleType would come from annotation object 
# but for this example we are manually adding sampleType column
sampleType <- c("Condition1", "Condition2")
exScores <- cbind(exScores, sampleType)
exScores

## -----------------------------------------------------------------------------
data("exampleBSDT", package="MIRA")
head(exampleBSDT)

## ----message=FALSE------------------------------------------------------------
data("exampleRegionSet", package="MIRA")
head(exampleRegionSet)

## ----message=FALSE------------------------------------------------------------
library(MIRA)
library(GenomicRanges) # for the `resize`, `width` functions
data("exampleRegionSet", package="MIRA")
data("exampleBSDT", package="MIRA")

## -----------------------------------------------------------------------------
BSDTList <- list(exampleBSDT)
names(BSDTList) <- "Gm06990_1"

## -----------------------------------------------------------------------------
BSDTList <- addMethPropCol(BSDTList)

## -----------------------------------------------------------------------------
mean(width(exampleRegionSet))

## -----------------------------------------------------------------------------
exampleRegionSet <- resize(exampleRegionSet, 4000, fix="center")
mean(width(exampleRegionSet))

## -----------------------------------------------------------------------------
exampleRegionSetGRL <- GRangesList(exampleRegionSet)
names(exampleRegionSetGRL) <- "lymphoblastoid_NRF1"

## ----Aggregate_methylation, message=FALSE, warning=FALSE----------------------
bigBin <- lapply(X=BSDTList, FUN=aggregateMethyl, GRList=exampleRegionSetGRL, 
                binNum=11)
bigBinDT <- bigBin[[1]]

## ----Plot profiles, message=FALSE, warning=FALSE------------------------------
sampleName = rep(names(bigBin), nrow(bigBinDT))
bigBinDT = cbind(bigBinDT, sampleName)
plotMIRAProfiles(binnedRegDT=bigBinDT)

## ----Scoring, warning=FALSE---------------------------------------------------
sampleScores <- calcMIRAScore(bigBinDT,
                        regionSetIDColName="featureID",
                        sampleIDColName="sampleName")
head(sampleScores)

## ----eval=FALSE---------------------------------------------------------------
# library(LOLA)
# pathToDB <- "path/to/LOLACore/hg38"
# regionDB <- loadRegionDB(pathToDB)

# PACKAGE DOCUMENTATION
#' Methylation-based Inference of Regulatory Activity (MIRA)
#' 
#' MIRA is a score that infers regulatory activity of genomic elements
#' based on DNA methylation data. It assesses the degree of dip in methylation
#' level surrounding a regulatory site of interest, such as 
#' transcription factor binding sites.
#' This package provides functions for aggregating methylation 
#' data across region sets, in bins.
#'
#' @docType package
#' @name MIRA
#' @author Nathan Sheffield
#' @author John Lawson
#'
#' @references \url{http://github.com/databio}
#' @importFrom GenomicRanges GRanges GRangesList elementMetadata strand
#'             seqnames granges
#' @importFrom ggplot2 ggplot aes facet_wrap geom_boxplot geom_jitter geom_line
#'             theme_classic xlab ylab geom_hline ylim scale_color_discrete
#'             scale_x_discrete scale_fill_brewer scale_color_manual
#'             scale_color_brewer
#' @import BiocGenerics S4Vectors IRanges
#' @importFrom data.table ":=" setDT data.table setkey fread setnames 
#'             setcolorder rbindlist setattr setorder copy is.data.table
#' @importFrom Biobase sampleNames
#' @importFrom stats lm coefficients poly
#' @importFrom bsseq getCoverage getMeth
#' @importFrom methods is
NULL


# Because of some issues with CRAN submission, 
# (see here: http://stackoverflow.com/questions/9439256/)
# I have to register stuff used in data.table as non-standard evaluation, 
# in order to pass some R CMD check NOTES.
if (getRversion() >= "2.15.1") {
    utils::globalVariables(c(
    ".", "bin", "binID", "chr", "element_blank", "featureID", 
    "geom_violin", "methylCount", "id", "meth", 
    "methylProp", "coverage", "sumCoverage", "regionGroupID", "regionID", 
    "sampleName", "sampleType", "theme", "ubinID", "V1"))
}

##########################################################################

#' Aggregate methylation data to get
#' a summary methylation profile for each region set
#' 
#' The main function for aggregating methylation data in MIRA analysis. 
#' Aggregates methylation across all regions in a given region set to
#' give a summary methylation profile for each region set. 
#' 
#' 
#' Each region is split into bins. For a given set of regions, 
#' methylation is first aggregated (averaged) within each 
#' bin in each region. Then methylation from corresponding bins from each
#' region are aggregated (averaged) across all regions 
#' (all first bins together, all second bins together, etc.), 
#' giving an aggregate methylation profile.
#' This process is done for each region set.
#'
#' @param BSDT A single data.table that has DNA methylation data on individual 
#' sites. Alternatively a BSseq object is allowed which will be converted 
#' internally to data.tables. The data.table input should have columns:
#' "chr" for chromosome, "start" for 
#' cytosine coordinate, "methylProp" for proportion of 
#' methylation (0 to 1), optionally "methylCount" 
#' for number of methylated reads, and
#' optionally "coverage" for total number of reads.

#' @param GRList A GRangesList object containing region sets, each set 
#' corresponding to a type of regulatory element. 
#' Each region set in the list should
#' be named. A named list of data.tables also works. 
#' @param binNum How many bins each region should be split into for aggregation 
#' of the DNA methylation data.
#' @param minBaseCovPerBin Screen out region sets that have any bins in the
#' final methylation profile with 'sumCoverage' below the 'minBaseCovPerBin'
#' threshold. 'sumCoverage' is an output column: during aggregation, 
#' the 'coverage' values for each base in a bin are added, then these sums
#' are added for corresponding bins from all regions, producing a 
#' 'sumCoverage' value for each bin. 'minBaseCovPerBin' is only 
#' used if there is a "coverage" column in the input methylation data.table.
#' 'sumCoverage' is greater than or equal to the number of separate reads
#' that contributed to a given bin.
#' 
#' @return a data.table with binNum rows for each region set containing
#' aggregated methylation data. If the input was a BSseq object
#' with multiple samples, a list of data.tables will be returned with
#' one data.table for each sample.
#' Each region was split into bins; methylation was put in these bins; 
#' Output contains sum of the all corresponding bins for the regions of each 
#' region set, ie for all regions in each region set: first bins summed, second 
#' bins summed, etc. Columns of the output should be "bin", "methylProp", 
#' "sumCoverage" (only if coverage was an input column, described below),
#' "featureID" (ID for 
#' the region set).
#' For information on symmetry of bins and output when a region set has
#' strand info, see ?BSBinAggregate.
#' 'sumCoverage' is calculated as follows: during aggregation, 
#' the 'coverage' values for each base in a bin are added, then these sums
#' are added for corresponding bins from all regions, producing a 
#' 'sumCoverage' value for each bin.
#' 
#' @export
#' @examples
#' data("exampleBSDT", package = "MIRA")
#' data("exampleRegionSet", package = "MIRA")
#' exBinDT <- aggregateMethyl(exampleBSDT, exampleRegionSet)
aggregateMethyl <- function(BSDT, GRList, binNum = 11, minBaseCovPerBin = 500){
    
    if (is(BSDT, "BSseq")) {
        # if input is not a data.table but rather a BSseq object
        # bsseq objects can include multiple samples so make a list
        
        ## not adding sample name to BSDT because of memory it would require
        ## so sample names are no longer required in BSseq object
        # # checking for sample names
        # if (length(sampleNames(BSDT)) != ncol(BSDT)) {
        #     stop(cleanws("BSseq object must have sample name for each sample.
        #                 Check output of bsseq::sampleNames(BSDT)"))
        # }
        BSDTList <- bsseqToDataTable(BSDT)
        
        ## not adding sample name to BSDT because of memory it would require
        # # for each data.table, make a sampleName column with the appropriate
        # # name (by reference)
        # mapply(FUN = function(x, y) x[, sampleName := y], 
        #        BSDTList,
        #        names(BSDTList))
        # do the aggregation step on each data.table
        bigMethylByBin <- lapply(X = BSDTList, 
                                FUN = function(x) aggregateMethylInt(BSDT = x, 
                                                                     GRList = GRList, 
                                                                     binNum = binNum, 
                                                                     minBaseCovPerBin = minBaseCovPerBin))
    } else {
        bigMethylByBin <- aggregateMethylInt(BSDT = BSDT, 
                                            GRList = GRList, 
                                            binNum = binNum, 
                                            minBaseCovPerBin = minBaseCovPerBin)
    }
    
    

    return(bigMethylByBin)
}

aggregateMethylInt <- function(BSDT, GRList, binNum = 11, minBaseCovPerBin = 500) {
    ######### aggregateMethyl:Preprocessing and formatting###############
    # BSDT should not be a list but can be converted
    if (is(BSDT, "list")) {
        if (length(BSDT) == 1) {
            BSDT <- BSDT[[1]]
        } else {
            stop(cleanws("Only one BSDT may be given to function. 
                         BSDT should not be a list."))
        }
        }
    if (!is(BSDT, "data.table")) {
        stop("BSDT must be a data.table")
    }
    
    # converting to list format if GRList is a data.table or GRanges object
    if (is(GRList, "GRanges")) {
        GRList <- GRangesList(GRList)
        message("Converting to GRangesList...")
    }
    if (is(GRList, "data.table")) {
        GRList <- list(GRList)
        message("Converting to list...")
    }
    
    # checking that input is in list format
    # should be either list or "GRangesList"
    if (!(is(GRList, "list") || is(GRList, "GRangesList"))) {
        stop("GRList should be a named list/GRangesList.")
    }
    
    # checking if region sets have names
    if (is.null(names(GRList))) {
        warning(cleanws("GRList should be a named list/GRangesList. 
                        The region sets were assigned sequential names 
                        based on their order in the list."))
        names(GRList) <- paste0(rep("RegionSet", length(GRList)), 
                                seq_along(GRList))
    }
    
    # checking that all objects in GRList are the same type 
    # and converting to data.tables
    # first check if all objects are GRanges
    if (all(sapply(X = GRList, FUN = function(x) is(x, "GRanges")))) {
        # GRanges to data.tables
        GRDTList <- lapply(X = GRList, FUN = grToDt, includeStrand = TRUE)
        
        # next check if all objects are data.tables 
    }else if (all(sapply(X = GRList, FUN = function(x) is(x, "data.table")))) {
        
        GRDTList <- GRList # this case is okay
    }else{
        stop("GRList should be a GRangesList or a list of data.tables")
    }
    
    # warning user if not all regions in a region set are the same length
    # which could make the resulting MIRA profile hard to interpret
    hasUniformRegionSizes = all(sapply(GRDTList, function(x) 
                                    diff(range(x$end - x$start)) < 0.000001)) 
    if (!hasUniformRegionSizes) {
        warning(cleanws("For at least one of the region sets, not all regions
                        in the set were the same length. It is recommended 
                        that all regions in a given region
                        set be the same length so the final profile will be 
                        easier to interpret. Regions can be resized outside MIRA
                        to meet this recommendation."))
    }
    
    
    
    
    # adding a methylProp column if it is not already in the BSDT
    if (!("methylProp" %in% names(BSDT))) {
        BSDTList <- addMethPropCol(list(BSDT))
        BSDT <- BSDTList[[1]] 
    }
    
    # checking for a coverage column in BSDT
    hasCoverage <- "coverage" %in% colnames(BSDT)
    
    
    ######## aggregateMethyl:Binning and processing output####################
    
    # list of data.tables but some list items could be NULL
    methylByBin <- lapply(X = GRDTList, 
                         FUN = function(x) BSBinAggregate(BSDT = BSDT, 
                                                          rangeDT = x, 
                                                          binNum = binNum, 
                                                          splitFactor = NULL, 
                                                          minBaseCovPerBin = minBaseCovPerBin,
                                                          hasCoverage = hasCoverage))
    names(methylByBin) <- names(GRList)# preserving names
    # adding a feature ID column to each data.table that 
    # should identify what region set was used
    for (i in seq_along(methylByBin)) {
        # if it wasn't a data.table, this would give an error
        if (is.data.table(methylByBin[[i]])) {
            methylByBin[[i]][, featureID := rep(names(methylByBin)[i], 
                                            nrow(methylByBin[[i]]))][]
        }
    }
    # screening out region sets that had incomplete binning
    binNumScreen <- sapply(X = methylByBin, FUN = NROW) # NROW gives 0 for NULL
    # taking out incomplete region sets
    removeInd = binNumScreen < binNum
    # tell user what region sets had no overlap with BSDT and were screened out
    if (any(removeInd)) {
        # will cause an error later on if length(removeInd) = 0
        methylByBin <- methylByBin[!removeInd] 
        # names of removed sets
        removedRS = paste0(names(GRList)[removeInd], collapse = ", ")
        warning(c( cleanws("The following region sets were screened out for 
                        this sample. Reasons include no overlap between region set and BSDT
                        or at least one bin being below minBaseCovPerBin. Region sets: "),
                   removedRS, "."))
    }
    
    bigMethylByBin <- rbindlist(methylByBin)
    ## letting user take care of sampleName stuff outside aggregateMethyl()
    # sampleNameInBSDT <- "sampleName" %in% colnames(BSDT)
    # if (sampleNameInBSDT && (ncol(bigMethylByBin) != 0)) {
    #     # creating new sampleName column
    #     bigMethylByBin[, sampleName := rep(BSDT[1, sampleName])][] 
    # }
    
    
    # not using hasCoverage since if all region sets didn't overlap 
    # with BSDT then bigMethylByBin
    # will be a null data.table with no column names (hasCoverage only applies to BSDT)
    if ("coverage" %in% colnames(bigMethylByBin)) {
        # changing coverage col name to be more clear that it is a different type
        # of coverage than input coverage
        setnames(bigMethylByBin, "coverage", "sumCoverage")
    }
    
    return(bigMethylByBin)
}


# Get MIRA score for each sample/region set combination
# 
# Takes methylation data and sets of regions then aggregates
# methylation for each region set and scores the resulting profile.
# A wrapper for aggregateMethyl and calcMIRAScore but it does not return
# the summary methylation profiles, just the scores. This function is 
# given only for convenience in working with small numbers of samples/region
# sets. For large analyses, "aggregateMethyl" and "calcMIRAScore" are recommended.
# See vignettes for recommended use of MIRA.
#
# @param BSDT A single data table that has DNA methylation data on individual 
# sites. Alternatively a BSseq object may be input which will be converted 
# internally to data.table/s (sample names must be in BSseq object). 
# For the data.table input, it should 
# include a "chr" column with chromosome, a "start" column with the 
# coordinate number for the cytosine, a "methylProp" column with proportion of 
# methylation (0 to 1), optionally a "methylCount" column with 
# number of methylated reads 
# for each site, and optionally a "coverage" column with 
# total number of reads for each 
# site.

# @param GRList A GRangesList object containing region sets, each set 
# corresponding to a regulatory element (or having regions with the 
# same biological annotation).
# Each region set in the list should be named. 
# @param binNum How many bins each region should be split into for aggregation 
# of the DNA methylation data.
# @param scoringMethod Method to calculate MIRA score after binning. 
# "logRatio" is currently the only option. See calcMIRAScore function.
# @param minBaseCovPerBin Screen out region sets that have any bins in the
# final methylation profile with 'sumCoverage' below the 'minBaseCovPerBin'
# threshold. 'sumCoverage' is an output column: during aggregation, 
# the 'coverage' values for each base in a bin are added, then these sums
# are added for corresponding bins from all regions, producing a 
# 'sumCoverage' value for each bin. 'minBaseCovPerBin' is only 
# used if there is a "coverage" column in the input methylation data.table.
# 'sumCoverage' is greater than or equal to the number of separate reads
# that contributed to a given bin.
# @return A data.table with a MIRA score for each region set in GRList. 
# See ?calcMIRAScore. 
# If input for "BSDT" is a BSseq object, output will be a list of 
# data.tables if there were multiple samples in the BSseq object (named
# list if sample names were in BSseq object). 
# @examples 
# data("exampleBSDT", package = "MIRA") 
# data("exampleRegionSet", package = "MIRA") 
# MIRAScore(BSDT = exampleBSDT, GRList = exampleRegionSet)
# 
#
MIRAScore <- function(BSDT, GRList, binNum = 11, scoringMethod = "logRatio", 
                     minBaseCovPerBin = 500){

    ## not requiring sampleName column to save memory
    # # checking for sampleName column
    # if (is(BSDT, "data.table")) {
    #     if (!("sampleName" %in% colnames(BSDT))) {
    #         stop("sampleName column must be present in BSDT")
    #     }
    # } 
    
    # if BSseq object was given, convert to a list of data.tables
    # then run aggregation on each with lapply
    if (is(BSDT, "BSseq")) {
        ## not requiring sampleName to save on memory
        # # checking for sample names
        # if (length(sampleNames(BSDT)) != ncol(BSDT)) {
        #     stop(cleanws("BSseq object must have sample name for each sample.
        #                 Check output of bsseq::sampleNames(BSDT)"))
        # }
        BSDTList <- bsseqToDataTable(BSDT)
        ## not adding sampleName column in order to save on memory
        # # for each data.table, make a sampleName column with the appropriate
        # # name (by reference)
        # mapply(FUN = function(x, y) x[, sampleName := y], 
        #        BSDTList,
        #        names(BSDTList))
        sampleNames = names(BSDTList) # could be NULL
        bigBinList <- lapply(X = BSDTList, 
               FUN = function(x) aggregateMethylInt(BSDT = x, 
                                                    GRList = GRList, 
                                                    binNum = binNum, 
                                                    minBaseCovPerBin = minBaseCovPerBin))
        
        # using binned methylation data to calculate MIRA score
        scoreDT <- lapply(X = bigBinList, FUN = function(x) x[, .(score = calcMIRAScore(methylProp, 
                                                                        method = scoringMethod)), 
                                                   by = .(featureID)])
        if (!is.null(sampleNames)) {
            setnames(scoreDT, sampleNames)
        }
    } else {
        
        bigBin <- aggregateMethyl(BSDT = BSDT, GRList = GRList, binNum = binNum, 
                             minBaseCovPerBin = minBaseCovPerBin)
        # using binned methylation data to calculate MIRA score
        scoreDT <- bigBin[, .(score = calcMIRAScore(methylProp, 
                                              method = scoringMethod)), 
                         by = .(featureID)]
        
    }
  
    
    return(scoreDT)
}

#' Score methylation profile based on its shape
#' 
#' This will take a data.table
#' that has the methylation level in each bin in the MIRA profile and
#' return a single score. For the "logRatio" method, this score summarizes 
#' how large the 'dip' 
#' in methylation is at the center of that methylation profile.
#' A column for sample ID/name and a column for region set ID/name
#' should be included in the data.table because a separate score will be given 
#' for each sample/region set combination.
#'  
#' See `method` parameter for details on scoring calculations.
#' 
#' @param binnedDT A data.table with columns for:
#' bin ("bin"), methylation level ("methylProp"), 
#' region set ID/name (default expected column name is "featureID" 
#' but this is configurable via a parameter), sample name (default expected column name is 
#' "sampleName" but this is configurable via a parameter). 
#' The bin column is not used for calculations since it is assumed by
#' the function that the rows will be in the order of the bins (so the
#' function will work without a bin column although the bin column assists
#' in human readability of the input data.table) 
#' @param shoulderShift Used to determine the number of bins away from the 
#' center to use as the shoulders. Default value "auto" optimizes the 
#' shoulderShift variable for each sample/region set combination to try find the 
#' outside edges of the dip. shoulderShift may be manually set as an integer
#' that will be used for all sample/region set combinations. "auto" does not 
#' currently work with region sets that include strand info.
#' 
#' Brief description/example of the algorithm for "auto": for concave up MIRA
#' profiles with an odd number of bins, the first potential shoulder 
#' will be the 2nd bin from the center (if the center was 0). This is
#' the first bin that could not be included in center methylation value for 
#' scoring. From there, the shoulder will be changed to the next bin towards
#' the outside of the profile if the next bin over has a higher methylation
#' value or if the average methylation value of the next two bins are 
#' higher than the methylation value of the current shoulder bin. The 
#' potential shoulder bin keeps moving outward toward the edges of the MIRA
#' profile until neither of these conditions are met and whatever
#' bin it stops on is used for the shoulder in the MIRA
#' score calculation. For symmetrical MIRA profiles (the general use case),
#' the shoulders picked on both sides of the center will be the same number of 
#' bins away from the center bin (symmetrical shoulders). 
#' @param method The scoring method. "logRatio" is the log of the ratio of outer
#' edges to the middle. This ratio is the average of outside values 
#' of the dip (shoulders) divided by either the center value if 
#' it is lower than the two surrounding values (lower for concave up profiles or
#' higher for concave down profiles) or if it is not lower (higher for
#' concave down profiles), an 
#' average of the three middle values. For an even binNum, the middle four
#' values would be averaged with the 1st and 4th being weighted by half (as
#' if there were 3 values). 
#' A higher score with "logRatio" corresponds to a deeper dip. "logRatio" is the
#' only scoring method currently but more methods may be added in the future.
#' @param usedStrand If strand information is included as part of an
#' input region set when aggregating methylation, 
#' the MIRA profile will probably not be 
#' symmetrical. In this case, the automatic 
#' shoulderShift sensing (done when shoulderShift="auto") needs to
#' be done for both sides of the dip instead of just one side so set
#' usedStrand=TRUE if strand was included for a region set.
#' usedStrand=TRUE only has an effect on the function when shoulderShift="auto".
#' @param regionSetIDColName A character object. The name of the column
#' that has region set names/identifiers.
#' @param sampleIDColName A character object. The name of 
#' the column that has sample names/identifiers.
#' 
#' @return A data.table with a column for region set ID 
#' (default name is featureID), sample ID (default name is sampleName), 
#' and MIRA score (with name "score"). There will
#' be one row and MIRA score for each sample/region set combination.
#' The MIRA score quantifies the "dip" of 
#' the MIRA profile which is an aggregation of methylation 
#' over all regions in a region set. 
#' 
#' @export
#' @examples
#' data("exampleBins")
#' calcMIRAScore(exampleBins)
#' 
calcMIRAScore <- function(binnedDT, 
                    shoulderShift = "auto", 
                    method = "logRatio",
                    usedStrand = FALSE,
                    regionSetIDColName = "featureID",
                    sampleIDColName = "sampleName"){
    
    if (is(binnedDT, "data.table")) {
    
        # the expected/necessary columns
        expectedCols <- c("methylProp", regionSetIDColName,
                         sampleIDColName)
        expectedColsPresent <- expectedCols %in% colnames(binnedDT)
        
        if (!all(expectedColsPresent)) {
            stop(paste("Missing the following expected columns:",
                       paste(expectedCols[!expectedColsPresent], collapse=" "), 
                       sep=" "))
        }
            
        scoreDT <- binnedDT[, .(score = scoreDip(methylProp, 
                                                   shoulderShift=shoulderShift,
                                                   method=method,
                                                   usedStrand=usedStrand)), 
                           by = .(get(regionSetIDColName), get(sampleIDColName))] 
        #fixing names (not assigned normally because of using "get")
        setnames(scoreDT, c(regionSetIDColName, sampleIDColName, "score"))
    } else if (is(binnedDT, "numeric")) {
        # if binnedDT is actually a vector as was original behaviour of function
        # preserving ability to use calcMIRAScore on a single vector or in a 
        # data.table j expression
        # scoring by sample and region set will be accomplished outside
        # this function in the "by" part of the data.table expression
        # output is called scoreDT but is actually a single number object
        scoreDT <- scoreDip(values=binnedDT,
                    shoulderShift=shoulderShift,
                    method=method,
                    usedStrand=usedStrand)
    } else {
        # the preferred input is data.table
        stop("Input should be a data.table object")
    }
        
    return(scoreDT)
}


# This function was the original scoreDip but it was a wrapper was
# created to add some features and simplify the user interface.
# This will take a vector
# describing the methylation pattern and return a single score summarizing
# that vector for how large the 'dip' in methylation is at the center of
# the vector.
# @param values A vector with proportion of methylation values for each bin. 
# Between 0 and 1.
# @return A MIRA score. The MIRA score quantifies the "dip" of 
# the MIRA profile which is an aggregation of methylation 
# over all regions in a region set. 
# @examples
# data("exampleBins")
# exampleBins[, .(score = scoreDip(methylProp)), 
# 
scoreDip <- function(values, 
                    shoulderShift = "auto", 
                    method = "logRatio",
                    usedStrand = FALSE){
    
    if (!(method %in% "logRatio")) { # add new methods eventually
        stop("Invalid scoring method. Check spelling/capitalization.")
    }
    
    # determining number of bins
    binNum <- length(values)
    
    # determining whether profile is concave up or down in general
    # because values for finding shoulder need to be altered if concave
    # down ('logratio scoring') 
    # also it matters for getting middle value for 'logratio' scoring
    concaveUp <- isProfileConcaveUp(values, binNum)
    
    if (method == "logRatio") {
        centerSpot <- (binNum + 1) / 2 # X.5 for even binNum
        
        
        if ((binNum %% 2) == 0) { # if binNum is even, centerSpot is X.5
            # if one of middle 2 vals is lowest, use it, otherwise average
            # order of midVals vector matters because of which.min
            midVals=values[c(centerSpot - .5, centerSpot + .5, centerSpot - 1.5,
                             centerSpot + 1.5)]
            if (which.min(midVals) == 1) { # first middle bin
                midpoint <- midVals[1]
            } else if (which.min(midVals) == 2) { # second middle bin
                midpoint <- midVals[2]
            } else { # otherwise take average
                # includes 4 bins but outer two bins are weighted by half
                # approximates having 3 middle bins
                midpoint <- (.5 * values[centerSpot - 1.5] 
                            + values[centerSpot - .5]
                            + values[centerSpot + .5] 
                            + 0.5 * values[centerSpot + 1.5]) / 3    
            }
        }else {# if binNum is odd, centerSpot is X.0
            
            # if the middle is lowest for concave up/highest for concave down
            # use it, otherwise average will be taken
            if (concaveUp) {
                # order matters in which.min (for ties) so centerSpot is first
                useMiddlePoint <- (which.min(values[c(centerSpot, 
                                                      centerSpot - 1, 
                                                      centerSpot + 1)]) == 1)
            } else {
                # if concave down, see if middle point is the max of 
                # the three middle points
                useMiddlePoint <- (which.max(values[c(centerSpot, 
                                                      centerSpot - 1, 
                                                      centerSpot + 1)]) == 1)
            }
            
            if (useMiddlePoint) {
                midpoint <- values[centerSpot]
            } else { # if centerSpot does not have lowest/highest value of 
                # the three, average the three middle bins
                midpoint <- (values[centerSpot] + values[centerSpot + 1] 
                            + values[centerSpot - 1] ) / 3
            }
        }
        # automatically figuring out shoulderShift based on each profile
        if (shoulderShift == "auto") {
            
            
            
            if (concaveUp) {
                values2 <- values 
            } else {
                # converts to concave up so same `findShoulder` algorithm 
                # can be used for both cases
                # values2 is not used for scoring, just for finding shoulders
                values2 <- 1 - values 
            }
            
            
            
            # profile will probably not be symmetrical if strand was used
            if (usedStrand) { # probably not common but still an option
                shoulderShiftL <- findShoulder(values2, binNum, centerSpot,
                                             whichSide = "left")
                shoulderShiftR <- findShoulder(values2, binNum, centerSpot, 
                                             whichSide = "right")
            } else { # most common use case, strand was not used
                # either side would work since profile is symmetrical
                shoulderShift <- findShoulder(values2, binNum, centerSpot, 
                                             whichSide = "right")
            }
        }
        
        
        
        # floor and ceiling are only relevant when binNum is even 
        #(which means centerSpot is X.5)
        if (usedStrand && (shoulderShift == "auto")) { # probably uncommon case
            # floor and ceiling should not matter when "auto" is used but
            # I kept them just in case
            leftSide <- floor(centerSpot - shoulderShiftL)  
            rightSide <- ceiling(centerSpot + shoulderShiftR)
        } else { # most common case, strand was not used,
            #"auto" may or may not have been used
            leftSide <- floor(centerSpot - shoulderShift)  
            rightSide <- ceiling(centerSpot + shoulderShift)
        }
        shoulders <- ((values[leftSide] + values[rightSide]) / 2)
        if (midpoint < .000001) {
            warning("Division by zero. Consider adding a small constant 
                    to all bins for this region set.")
        }
        if (shoulders < .000001) {
            warning("Taking log of zero. Consider adding a small constant 
                    to all bins for this region set.")
        }
        # log ratio...
        score <- log(shoulders / midpoint)
    }

    # # alternate way of scoring by the area in the dip
    # if (method == "area") {
    #     maxMethyl <- max(values)
    #     score <- maxMethyl * binNum - sum(values)
    # }

    # # another alternate method
    # if (method == "parabola") {
    #     # fit2 <- lm(y~poly(x, 2, raw = TRUE))
    #     # lines(xx, predict(fit2, data.frame(x = xx)), col = "green")
    # }
    return(score)
}

# helper function for determining concavity of MIRA profile
# fits a parabola to the values then looks at the x^2 coefficient to 
# determine concavity (+ is concave up, - is concave down)
# if number of bins is high enough, a wide parabola is fit using all the data
# and then a narrow parabola is fit using the middle 50% or so values. The
# fit with the best adjusted R^2 value is used. This could help when the
# dip is mostly in the middle half but is somewhat arbitrary and 
# there might be a better way to do this.
# @return TRUE if concave up, FALSE if concave down
isProfileConcaveUp <- function(values, binNum) {
    wideFit <- lm(values ~ poly(seq_along(values), 2))
    wideX2Coef <- coefficients(wideFit)[3]
    wideR2 <- summary(wideFit)$adj.r.squared
    # if x2 coef is positive, it is concave up
    concaveUp <- (wideX2Coef >= 0) # up is preferred so inclusive of 0
    
    # only do a narrow fit if enough bins are used
    # want at least 7 bins to be a part of the narrow fit (smallerHalf)
    # floor(15 / 2) = 7
    # because 3 bins can be used for center in scoring (with odd binNum) 
    # and we want at least 2 bins on each side of those center bins
    if (binNum >= 15) {
        # using middle 50% or so for this fit
        smallerHalf <- floor(binNum / 2)
        endFirstQuarter <- ceiling((binNum - smallerHalf) / 2)
        narrowInd <- c(endFirstQuarter + seq(smallerHalf)) # middle ~half
        
        narrowFit <- lm(values[narrowInd] ~ 
                           poly(seq_along(values[narrowInd]), 2))
        narrowX2Coef <- coefficients(narrowFit)[3] # the x^2 coefficient
        narrowR2 <- summary(narrowFit)$adj.r.squared
        
        # use narrow fit if it has a better R2
        if (narrowR2 > wideR2) {
            concaveUp <- (narrowX2Coef >= 0)
        }
        
    }
    
    return(concaveUp)
}

# helper function for automatic shoulder sensing
# for unsymmetrical profiles this function should be run twice, once
# with whichSide="right" and once with whichSide="left"
# only finds the right shoulder so to find the left shoulder, flip the 
# input values "values", then take length(values)-shoulderShift
# used in scoreDip
# @param whichSide the side of the profile to find the shoulder for
# @param for other params see ?scoreDip
# @return shoulderShift The distance from the center of the profile to the shoulder.
#         It may be X.0 (ie an integer) if centerSpot is an integer or 
#         X.5 if centerSpot was X.5

findShoulder <- function(values, binNum, centerSpot, whichSide="right"){
    if (whichSide == "left") {
        values <- rev(values)
    }
    
    # first value that's not part of midpoint calculations
    shoulderStart <- ceiling(centerSpot) + 2 
    shoulderSpot <- shoulderStart
    for (i in shoulderStart:(binNum - 2)) {
        if (values[i + 1] > values[i]) {
            shoulderSpot <- i + 1
        } else if (((values[i + 2] + values[i + 1]) / 2) > values[i]) {
            shoulderSpot <- i + 1
        } else {
            break()
        }
    }
    # testing the last/most outside point if appropriate
    if (shoulderSpot == (binNum - 1)) {
        if (values[shoulderSpot + 1] > values[shoulderSpot]) {
            shoulderSpot <- shoulderSpot + 1
        }
    }
    # should work for X.0 and X.5 values of centerSpot
    # assuming calculations for leftSide and rightSide vars stay the same
    shoulderShift <- shoulderSpot - centerSpot
    
    return(shoulderShift)
}




#' Add column for proportion of methylation
#' 
#' Adding methylProp column that has proportion of reads that were 
#' methylated for each site based on number of methylated reads
#' divided by total number of reads.
#' Note: Assigns methylProp column by reference with ":="
#' 
#' @param BSDTList A bisulfite datatable or list of datatables 
#' with a column for number of methylated reads (methylCount) and 
#' a column for number of total reads 
#' (coverage) for each cytosine that was measured.
#' @return The BSDTList but with extra `methylProp` column on each 
#' data.table in list.
#' @export
#' @examples 
#' data("exampleBSDT", package = "MIRA")
#' exampleBSDT[, methylProp := NULL] # removing methylProp column
#' addMethPropCol(list(exampleBSDT))
addMethPropCol <- function(BSDTList){

    # converting to a data.table list if it was a single data.table
    if (is(BSDTList, "data.table")) {
        BSDTList <- list(BSDTList)
    }

    # stopping the function if the input was not data.table originally
    if (!is(BSDTList[[1]], "data.table")) {
        stop('Input must be a single data.table object 
             or list of data.table objects')
    }

    # using anonymous function to apply operation 
    # that adds methylProp column to each element of list
    # extra [] on the end is necessary for proper display/printing of the object
    BSDTList <- lapply(X = BSDTList, 
                    FUN = function(x) x[, methylProp := 
                                            round(methylCount / coverage, 3)][])

    return(BSDTList)
}




#' Read in files from biseq meth caller
#' 
#' Parses the x/y format of methylation calls, 
#' splitting them into individual columns: "methylCount" column for
#' number of methylated reads for site and "coverage" column for total
#' number of reads covering that site. Input files should have the following
#' columns: "chr", "start", "end", "meth", "rate", "strand".
#' 
#' 
#' This can run into memory problems if there are too many files...
#' because of the way parallel lacks long vector support. The solution is
#' to just use a single core; or to pass mc.preschedule = FALSE; This
#' makes it so that each file is processed as a separate job. Much better.
#' 
#' @param files a vector of file paths 
#' @param contrastList Generally not needed for MIRA. 
#' A list of named character vectors, 
#' each with length equal to the number of items in files. 
#' These will translate into column names in the final table.
#' @param cores number of processors.
#' @param returnAsList Whether to return the output as a list 
#' or as one big data.table.
#' @return Data from each input file joined together into one big data.table.
#' If returnAsList = TRUE, then input from each file will be 
#' in its own data.table in a list.
#' @examples
#' shortBSDTFile <- system.file("extdata", "shortRRBS.bed", package = "MIRA") 
#' shortBSDT <- BSreadBiSeq(shortBSDTFile)
#'
#' @export
BSreadBiSeq <- function(files, contrastList = NULL, 
                       cores = 4, returnAsList = FALSE) {
    
    cores <- min(length(files), cores); # not more cores than files!
    setLapplyAlias(cores);
    if (!is.null(contrastList)) {
        if (any(sapply(contrastList, length) != length(files))) {
            stop("contrastList must be a list, 
                 with each value having the same number of elements as files.");
        }
    }
    message("Reading ", length(files), " files..");
    freadList <- lapplyAlias(files, fread, mc.preschedule = FALSE);
    colNames <- names(contrastList)
    message("File reading finished (",
        length(files),
        " files). Parsing Biseq format...",
        appendLF = FALSE);
    # TODO: This parsing takes awhile, and could be done in parallel.
    freadListParsed <- lapplyAlias(freadList, parseBiseq, mc.preschedule = FALSE)

    message("Parsing complete, building final tables and cleaning up...")
    numberOfFiles <- length(freadListParsed);
    for (i in 1:numberOfFiles) {
        # if (numberOfFiles > 1) {
        #     message(i, ": ", sampleNames[i], "; ", appendLF = FALSE)
        # }
        # if (numberOfFiles > 1 && i == numberOfFiles) {
        #     message("", appendLF = TRUE)
        # }
        DT <- freadListParsed[[i]]; # convenience alias.
        if (!is.null(contrastList)) {
            DT[, get("colNames") := as.list(sapply(contrastList, "[[", i))]
        }
        # if (!is.null(sampleNames)) {
        #     DT[, sampleName := sampleNames[i]]
        # }
        freadListParsed[[i]] <- DT
    }

    # filteredList <- do.call(rbind, freadListParsed)
    # gc(); # rbind call is memory inefficient; this helps.
    # rbindlist supposedly does the same thing as do.call(rbind, list) but 
    # faster
    # default (returnAsList = FALSE) is to return as 
    # one combined data.table/data.frame
    if (!returnAsList) { 
        filteredList <- rbindlist(freadListParsed)
    }else{
        filteredList <- freadListParsed
    }

    return(filteredList);
}

# Takes a data.table from BSreadBiSeq and parses the strange x/y format
# of methylation calls, splitting them into individual columns
# @param DT data.table to parse
# "chr", "start", "end", "meth", "rate", "strand" columns expected
# in that order.
# @return data.table with separate methylated and unmethylated columns.
# Specific col names are set
parseBiseq <- function(DT) {
    message(".", appendLF = FALSE);
    setnames(DT, paste0("V", 1:6), 
             c("chr", "start", "end", "meth", "rate", "strand"))
    DT[, meth := gsub("'", "", meth)]
    # split the '12/12' format of meth calls
    ll <- unlist(strsplit(DT$meth, "/", fixed = TRUE))
    idx <- seq(1, length(ll), by = 2)
    DT[, `:=` (methylCount = as.integer(ll[idx]), 
              coverage = as.integer(ll[idx + 1]))]
    DT[, start := as.integer(start + 1)] # re-index
    DT[, c("rate", "end", "meth" ) := NULL] # remove unnecessary columns
    DT[, strand := NULL]
    DT <- DT[, list(methylCount = sum(methylCount), coverage = sum(coverage)), 
          by = list(chr, start)] # smash measurements
    setcolorder(DT, c("chr", "start", "methylCount", "coverage"));
    DT <- DT[ !grep("_", chr), ]; # clean Chrs
    return(DT)
}



# Given a BSDT (bisulfite data.table), remove any entries that overlap
# regions given in the excludeGR argument and/or filter out sites
# that have lower than a minimum number of reads.
# @param BSDT Bisulfite data.table to filter
# @param minReads Require at least this level of coverage at a cpg.
# @param excludeGR GRanges object with regions to filter.
# 
# @return The BSDT with appropriate regions removed.
BSFilter <- function(BSDT, minReads = 10, excludeGR = NULL) {
    # First, filter for minimum reads.
    if (minReads > 0) {
        BSDT <- BSDT[coverage >= minReads, ]
    }
    if (NROW(BSDT) == 0) { return(data.table(NULL)) }
    # Now, filter entries overlapping a region in excludeGR.
    if (!is.null(excludeGR)) {
        gr <- dtToGr(BSDT)
        fo <- findOverlaps(gr, excludeGR)
        qh <- unique(queryHits(fo))
        length(qh)
        nrow(BSDT)
        BSDT <- BSDT[-qh, ]
    }
    return(BSDT)
}

#Unit tests
library(MIRA)
library(GenomicRanges)
library(data.table)
library(bsseq)

context("Testthat context...")
# 
# #test that BSBinAggregate can deal with 0 methylation scores and 
# #low methylation in general 
# # and that it is not possible to get a negative proportion of methylation
# #test that nonunique regionSet gives result for the unique version of that region set
# #check what happens if annotation is messed up


######Testing binning and aggregation functions#######
#making test data
#making fake BSDT data to test

numBins <- 13 #don't change this (code below depends on it)
numCpG <- numBins
regionNum <- 2 #changing will break code
chr <- rep("chr1", numCpG * regionNum)#numCpG times number of separate regions in start 
#CpGs are 20 apart within region and first CpGs of each region are 1000 apart
start <- c((1:numCpG) * 20, ((1:numCpG) * 20 + 1000))
coverage <- rep(10000, numCpG * regionNum)
#linear increase
methylProp <- c(rep(1:numCpG / numCpG, regionNum))
methylCount <- coverage * methylProp
sampleName <- rep("TestData", numCpG * regionNum)
testBSDT <- data.table(chr, start, methylCount, coverage, methylProp, sampleName)
origtestBSDT <- copy(testBSDT) #so it can be the same for each test section

#making fake region data to test
chr <- rep("chr1", regionNum)
start <- c(10, 10 + 1000)
end <- c(numCpG * 20 + 10, numCpG * 20 + 1010)
strand <- c("+", "-")
testGR <- GRanges(seqnames = chr, ranges = IRanges(start, end), strand = strand)
testGRDT <- MIRA:::grToDt(testGR, includeStrand = TRUE)
origtestGRDT <- copy(testGRDT)
origtestGR <- copy(testGR)
#cleaning up variables so they are not used by data.table j expressions later
rm(list = c("chr", "start", "end", "strand", "methylProp", "methylCount", "coverage"))
rm("sampleName")

#(re)setting test objects
testBSDT <- copy(origtestBSDT)
testGR <- copy(origtestGR)
testGRDT <- copy(origtestGRDT)
test_that("binRegion is working and flipping - strand", {
    #making sure input is as I expect
    expect_equal(testGRDT[, strand], c("+", "-"))
    
    #testing that binRegion is reversing - strands during binning if given strand info
    
    #Using two regions, first has "+", second "-" strand
    #testing binregion as a "j command"
    testBins <- testGRDT[, binRegion(start, end, numBins, chr, strand)]
    expect_equal(testBins$id, rep(c(1, 2), each = 13))#testing id col
    expect_equal(testBins$binID, rep(1:numBins, 2))#testing binID col
    expect_equal(testBins[17, start], 1190) #spot check
    #testing range of binned region
    s2 <- testGRDT[2, start]
    e2 <- testGRDT[2, end]
    #lowest value is original start
    expect_equal(min(testBins[1:numBins + numBins, start]), s2)
    expect_true(max(testBins[1:numBins + numBins, start]) < e2)#all starts are in range
    #highest value is original end
    expect_equal(max(testBins[1:numBins + numBins, end]), e2)
    expect_true(min(testBins[1:numBins + numBins, end]) > s2)#all ends are in range
    #check that size of output is as expected 
    #(each Region should have been split up into binNum rows)
    expect_equal(nrow(testBins), (numBins * regionNum) )
    #last start val should be less than first if orientation was flipped
    #due to "-" strand on second region as it should have been
    expect_true(testBins[numBins * 2, start] < testBins[numBins + 1, start])
    
    #testing binRegion with two "+" strands
    testGRDT[, strand := c("+", "+")]
    testBins <- testGRDT[, binRegion(start, end, numBins, chr, strand)]
    expect_equal(testBins[17, start], 1070) #spot check
    #last start val should be greater than first if orientation was not flipped
    expect_true(testBins[numBins * 2, start] > testBins[numBins + 1, start])
    
    
    #testing binRegion with no strand (should be equivalent to "*")
    testBins <- testGRDT[, binRegion(start, end, numBins, chr)]
    expect_equal(testBins[17, start], 1070) #spot check
    #last start val should be greater than first if orientation was not flipped
    expect_true(testBins[numBins * 2, start] > testBins[numBins + 1, start])
    #testing range of binned region
    s2 <- testGRDT[2, start]
    e2 <- testGRDT[2, end]
    #lowest value is original start
    expect_equal(min(testBins[1:numBins + numBins, start]), s2)
    #all starts are in range
    expect_true(max(testBins[1:numBins + numBins, start]) < e2)
    #highest value is original end
    expect_equal(max(testBins[1:numBins + numBins, end]), e2)
    expect_true(min(testBins[1:numBins + numBins, end]) > s2)#all ends are in range
    
})

#resetting test objects
testBSDT <- copy(origtestBSDT)
testGR <- copy(origtestGR)
testGRDT <- copy(origtestGRDT)
test_that("BSAggregate", {
    # NOTE: BSAggregate still can output a coverage column, (not sumCoverage)
    #making sure input is as I expect
    expect_equal(testGRDT[, strand], c("+", "-"))
    
    #setting up prereqs for BSAggregate
    binnedDT <- testGRDT[, binRegion(start, end, numBins, chr, strand)]
    binnedGR <- sapply(split(binnedDT, binnedDT$binID), dtToGr)
    #
    binnedBSDT <- 
        BSAggregate(BSDT = testBSDT, regionsGRL = GRangesList(binnedGR), 
                    jCommand = buildJ(c("methylProp", "coverage"), 
                                      c("mean", "sum"),
                                      newColNames=c("methylProp", "coverage")), 
                    byRegionGroup = TRUE, splitFactor = NULL)
    #all should be the same since having opposite strands resulted in
    #flipping the second region
    expect_equal(round(binnedBSDT[, methylProp], 2), rep(.54, nrow(binnedBSDT)))
    
    #now with no flipping of the second region (changing - to + )
    testGRDT[, strand := c("+", "+")]
    #adding to coverage so that not all coverage values will be the same
    #should not affect methylation aggregation
    testBSDT[numBins * 2, coverage := coverage * 2]
    binnedDT <- testGRDT[, binRegion(start, end, numBins, chr, strand)]
    binnedGR <- sapply(split(binnedDT, binnedDT$binID), dtToGr)
    binnedBSDT <-
        BSAggregate(BSDT = testBSDT, regionsGRL = GRangesList(binnedGR), 
                    jCommand = buildJ(c("methylProp", "coverage"), 
                                      c("mean", "sum"),
                                      newColNames=c("methylProp", "coverage")), 
                    byRegionGroup = TRUE, splitFactor = NULL)
    #all should be the same since having opposite strands resulted in
    #flipping the second region
    expect_equal(round(binnedBSDT[, methylProp], 2), round(1:numBins / numBins, 2))
    #testing that expected coverage in each bin is obtained
    expect_equal(binnedBSDT[, coverage], c(rep(20000, numBins - 1), 30000))
    
    #now with no strand info given
    #tests that no strand will be symmetrically averaged 
    #changing first value so symmetry comes from averaging, not from input shape
    testBSDT[1, methylProp := methylProp * 2]
    binnedDT <- testGRDT[, binRegion(start, end, numBins, chr)] #no strand
    binnedGR <- sapply(split(binnedDT, binnedDT$binID), dtToGr)
    binnedBSDT <- 
        BSAggregate(BSDT = testBSDT, regionsGRL = GRangesList(binnedGR), 
                    jCommand = buildJ(c("methylProp", "coverage"), 
                                      c("mean", "sum"),
                                      newColNames=c("methylProp", "coverage")), 
                    byRegionGroup = TRUE, splitFactor = NULL)
    #hard coded so may need to be updated later
    expect_equal(round(binnedBSDT[, methylProp], 2), 
                 c(.56, rep(.54, numBins - 2), .56))
    
    #test more than two CpG sites in one bin
    #putting 24th CpG very close to 25th CpG
    testBSDT[24, start := (testBSDT[25, start] - 2)]
    binnedDT <- testGRDT[, binRegion(start, end, numBins, chr, strand)] 
    binnedGR <- sapply(split(binnedDT, binnedDT$binID), dtToGr)
    binnedBSDT <-
        BSAggregate(BSDT = testBSDT, regionsGRL = GRangesList(binnedGR), 
                    jCommand = buildJ(c("methylProp", "coverage"), 
                                      c("mean", "sum"),
                                      newColNames=c("methylProp", "coverage")), 
                    byRegionGroup = TRUE, splitFactor = NULL)
    expect_equal(round(binnedBSDT[12, methylProp], 2), 0.9)
    
    #test that error is given if BSDT input does not have a "methylProp"...
    #...column with proportion of reads methylated
    testBSDT[, methylProp := NULL]
    expect_error(BSAggregate(BSDT = testBSDT, 
                             regionsGRL = GRangesList(binnedGR), 
                             jCommand = buildJ(c("methylProp", "coverage"), 
                                               c("mean", "sum"),
                                               newColNames=c("methylProp", "coverage")), 
                             byRegionGroup = TRUE, splitFactor = NULL))

})

###############testing scoring and wrapper functions#################
#resetting test objects
testBSDT <- copy(origtestBSDT)
testGR <- copy(origtestGR)
testGRDT <- copy(origtestGRDT)
test_that("aggregateMethyl and MIRAScore", {
    # NOTE: aggregateMethyl does not output a coverage column, now sumCoverage
    #making sure input is as I expect
    expect_equal(testGRDT[, strand], c("+", "-"))
    
    #testing aggregateMethyl, warning about names is expected
    # ignore warning about needing a named list/GrangesList
    binnedBSDT <- aggregateMethyl(BSDT = testBSDT, GRList = testGR, 
                              binNum = numBins, minBaseCovPerBin = 0)
    expect_equal(round(binnedBSDT[, methylProp], 2), rep(0.54, numBins))
    #testing that expected sumCoverage in each bin is obtained
    expect_equal(binnedBSDT[, sumCoverage], c(rep(20000, numBins)))
    
    # making sure the output is same for input of data.table or bsseq
    # making bsseq version of testBSDT (there should only be one sampleName)
    testBSDTbsseq <- BSseq(M=as.matrix(testBSDT$methylCount),
                          Cov=as.matrix(testBSDT$coverage),
                          chr=testBSDT$chr,
                          pos=testBSDT$start,
                          sampleNames=unique(testBSDT$sampleName))
    binnedBSDTbsseq <- aggregateMethyl(BSDT = testBSDTbsseq, GRList = testGR,
                                    binNum = numBins, minBaseCovPerBin = 0)
    names(binnedBSDTbsseq) <- NULL # taking off name for the following comparison
    expect_equal(binnedBSDTbsseq, list(binnedBSDT))
    # test whether aggregateMethyl deals with cases where BSDT doesn't overlap 
    # with region set/s or minBaseCovPerBin causes region set to be screened out
    # screened out
    screenedBSDT = suppressWarnings(aggregateMethyl(BSDT = testBSDT, GRList = testGR,
                                    binNum = numBins, minBaseCovPerBin = 1000000))
    expect_equal(nrow(screenedBSDT), 0)
    # for no overlap
    noOLGR <- GRanges(seqnames = c("chrN", "chrN"), 
                      ranges = IRanges(c(1, 100), c(10, 110)), 
                      strand = c("*", "*"))
    noOLBinnedBSDT= suppressWarnings(aggregateMethyl(BSDT = testBSDT, GRList = noOLGR,
                                     binNum = numBins, minBaseCovPerBin = 0))
    expect_equal(nrow(noOLBinnedBSDT), 0)

    
    
    # testing MIRAScore, warning about names is expected
    # ignore warning about needing a named list/GrangesList
    scoreDT <- MIRAScore(BSDT = testBSDT, GRList = testGR, binNum = numBins, minBaseCovPerBin = 0, 
                      scoringMethod = "logRatio")
    #since the MIRA signature was flat, score = 0
    expect_equal(scoreDT$score, 0)
    #region set name should have been given automatically
    expect_equal(scoreDT$featureID, "RegionSet1")
})

#resetting test objects
testBSDT <- copy(origtestBSDT)
testGR <- copy(origtestGR)
testGRDT <- copy(origtestGRDT)
test_that("calcMIRAScore, findShoulder, and isProfileConcaveUp", {
    
    #test with odd bin number
    x <- -10:10
    y <- x^2 + 1
    binNumber <- length(y) #21
    #default shoulderShift is based on length of input (number of bins)
    # ignore warning about "essentially perfect fit"
    testScore <- round(calcMIRAScore(binnedDT = y), 2)
    expScore <- round(log((mean(y[c(1, binNumber)])) / (y[11])), 2)
    expect_equal(testScore, expScore)
    
    #testing that averaging will happen if middle is not lowest value
    y[11] <- 5
    testScore <- round(calcMIRAScore(binnedDT = y), 2)
    expScore <- round(log((mean(y[c(1, binNumber)])) / ((y[10] + y[11] + y[12]) / 3)), 2)
    expect_equal(testScore, expScore)
    
    
    
    #testScore <- calcMIRAScore(binnedDT = y, shoulderShift = 9.5)
    #check by hand, expect_equal(round(testScore, 2), 3.62)
    
    #test with even bin number
    x <- -4:5
    y <- x^2 + 1
    binNumber <- length(y) #10
    # ignore warning about "essentially perfect fit"
    testScore <- round(calcMIRAScore(binnedDT = y), 2)
    expScore <- round(log(mean(y[c(1, binNumber)])
                        / y[5]), 2)
    expect_equal(testScore, expScore)
    #test with non default shoulderShift
    # ignore warning about "essentially perfect fit"
    testScore <- round(calcMIRAScore(binnedDT = y, shoulderShift = 3), 2)
    expScore <- round(log(mean(y[c(2, 9)]) / y[5]), 2)
    expect_equal(testScore, expScore)
    
    #testing results with automatic shoulder detection, symmetrical
    #chooses pos. 12 because (14+16)/2 is not > 15
    #this test will fail if standard is changed to >=
    jagged <- c(16, 14, 15, 11, 12, 7, 4, 4, 7, 12, 11, 15, 14, 16)
    testScore <- round(calcMIRAScore(binnedDT = jagged, shoulderShift = "auto"), 2)
    expScore <- round(log(mean(jagged[c(3, 12)]) / jagged[7]), 2)
    expect_equal(testScore, expScore)
    
    #testing that averaging will happen if middle point is not lowest
    jagged[c(7, 8)] <- 8 
    testScore <- round(calcMIRAScore(binnedDT = jagged, shoulderShift = "auto"), 2)
    expMidpoint <- (.5 * jagged[6] + jagged[7] + jagged[8] + .5 * jagged[9]) / 3
    expScore <- round(log(mean(jagged[c(3, 12)]) / expMidpoint), 2)
    expect_equal(testScore, expScore)
    
    #testing the findShoulder function with unsymmetrical input
    unsymmetric <- jagged
    unsymmetric[1] <- 17 #now the first spot should be counted as the shoulder
    centerSpot <- (1 + length(unsymmetric)) / 2
    rShoulderShift <- findShoulder(unsymmetric, length(unsymmetric), 
                                  centerSpot, whichSide = "right")
    expect_equal(rShoulderShift, 4.5)
    #middle is 7.5 outer edge is 1, shoulderShift should be 6.5
    lShoulderShift <- findShoulder(unsymmetric, length(unsymmetric), 
                                  centerSpot, whichSide = "left")
    expect_equal(lShoulderShift, 6.5)
    
    #testing calcMIRAScore function with unsymmetrical input
    unSymScore <- round(calcMIRAScore(binnedDT = unsymmetric, 
                                shoulderShift = "auto", usedStrand = TRUE), 2)
    expMidpoint <- (.5 * unsymmetric[6] + unsymmetric[7] + 
                       unsymmetric[8] + .5 * unsymmetric[9]) / 3
    #if symmetrical, you would use values 1 and 14 or 3 and 12
    expScore <- round(log(mean(unsymmetric[c(1, 12)]) / expMidpoint), 2)
    expect_equal(expScore, unSymScore)
    
    # testing calcMIRAScore with input of a data.table and no data.table syntax
    # when calling calcMIRAScore
    jagged <- c(16, 14, 15, 11, 12, 7, 4, 4, 7, 12, 11, 15, 14, 16)
    jagLen <- length(jagged)
    binnedDT <- data.table(bin=seq_along(jagged), methylProp=jagged, 
                          sampleName=rep("Sample1", jagLen), 
                          featureID=rep("RegionSet1", jagLen))
    newSyntaxScoreDT <- calcMIRAScore(binnedDT)
    newSyntaxScore <- round(newSyntaxScoreDT$score, 2)
    expScore <- round(log(mean(jagged[c(3, 12)]) / jagged[7]), 2)
    oldSyntaxScore <- round(binnedDT[, .(score=calcMIRAScore(methylProp)), 
                                    by=.(sampleName, featureID)]$score, 2)
    expect_equal(expScore, newSyntaxScore)
    expect_equal(oldSyntaxScore, newSyntaxScore)
    
    # testing isProfileConcaveUp
    jagged <- c(16, 14, 15, 11, 12, 7, 4, 4, 7, 12, 11, 15, 14, 16)
    expect_true(isProfileConcaveUp(jagged, 14))
    invJagged <- 1 - jagged
    expect_true(!isProfileConcaveUp(invJagged, 14))
    miniDip <- c(1, 3, 5, 8, 7, 5, 4, 5, 7, 8, 5, 3, 1)
    expect_true(!isProfileConcaveUp(miniDip, 13))
    miniDip2 <- c(1, miniDip, 1)
    expect_true(isProfileConcaveUp(miniDip2, 15))
    
    # testing that calcMIRAScore will give expected score
    testScore <- round(calcMIRAScore(miniDip2), 3)
    expScore <- round(log(mean(miniDip2[c(5,11)])/miniDip2[8]), 3)
    expect_equal(testScore, expScore)
    invMiniDip2 <- 10 - miniDip2
    testScore <- round(calcMIRAScore(invMiniDip2), 3)
    expScore <- round(log(mean(invMiniDip2[c(5,11)])/invMiniDip2[8]), 3)
    expect_equal(testScore, expScore)
})

##########testing miscellaneous functions##########
#resetting test objects
testBSDT <- copy(origtestBSDT)
testGR <- copy(origtestGR)
testGRDT <- copy(origtestGRDT)
test_that("addMethPropCol", {
    #Note: this function assigns methylProp column by reference ( := )
    #still returns object from function call though
    
    #making sure input is as I expect
    expect_equal(testGRDT[, strand], c("+", "-"))
    
    #testing if it returns expected column names, only adds "methylProp"
    testBSDT <- testBSDT[, methylProp := NULL]#removing methylProp column
    oldColNames <- colnames(copy(testBSDT))#copy avoids updating by reference
    addMethPropCol(testBSDT)#by reference, still returns object though
    newColNames <- colnames(testBSDT)
    colDiff <- base::setdiff(newColNames, oldColNames)
    expect_equal(colDiff, "methylProp")
    #testing that methylProp values are as expected
    expect_equal(round(testBSDT$methylProp, 2), rep(round(1:numCpG / numCpG, 2), 2))
})

#resetting test objects
testBSDT <- copy(origtestBSDT)
testGR <- copy(origtestGR)
testGRDT <- copy(origtestGRDT)
test_that("BSreadBiSeq",{
    
    tRRBS <- BSreadBiSeq(system.file("extdata", "shortRRBS.bed", package = "MIRA"))
    tRRBSCols <- c("chr", "start", "methylCount", "coverage")
    expect_equal(tRRBSCols, colnames(tRRBS))
    # coverage should be greater than or equal to methylCount, true for all
    compareCounts <- (tRRBS$coverage >= tRRBS$methylCount)
    expect_true(all(compareCounts))
})

#resetting test objects
testBSDT <- copy(origtestBSDT)
testGR <- copy(origtestGR)
testGRDT <- copy(origtestGRDT)
test_that("SummarizedExperimentToDataTable and bsseqToDataTable",{
    data("exampleBSseqObj")
    MIRAFormatBSDTList <- SummarizedExperimentToDataTable(coordinates = bsseq::granges(exampleBSseqObj), 
                                      methylCountDF = bsseq::getCoverage(BSseq = exampleBSseqObj, type = "M"), 
                                      coverageDF = bsseq::getCoverage(BSseq = exampleBSseqObj, type = "Cov"), 
                                      methylPropDF = bsseq::getMeth(BSseq = exampleBSseqObj, type = "raw"), 
                                      sample_names = bsseq::sampleNames(exampleBSseqObj))
    numLoci <- nrow(exampleBSseqObj)
    # checking that screening out noncovered C's is working
    # also accomplishes basic check that general length of output is as expected
    numNotCovered1 <- sum(getCoverage(exampleBSseqObj[, 1]) == 0)
    numNotCovered2 <- sum(getCoverage(exampleBSseqObj[, 2]) == 0)
    expect_equal(nrow(MIRAFormatBSDTList[[1]]), numLoci - numNotCovered1)
    expect_equal(nrow(MIRAFormatBSDTList[[2]]), numLoci - numNotCovered2)
    withinRange <- all((MIRAFormatBSDTList[[1]][, methylProp] <= 1) &
                          (MIRAFormatBSDTList[[1]][, methylProp] >= 0))
    # checking that methylProp values are within expected range
    expect_true(withinRange)
    # making sure coverage is greater than/equal to methylCount
    isCovGreater <- all(MIRAFormatBSDTList[[1]][, coverage] >= 
                           MIRAFormatBSDTList[[1]][, methylCount])
    expect_true(isCovGreater)
    
    
    # quick check of bsseqToDataTable
    MIRAFormatBSDTList2 <- bsseqToDataTable(exampleBSseqObj)
    expect_equal(MIRAFormatBSDTList, MIRAFormatBSDTList2)
})

#############cleaning up the environment after finishing tests##############

---
title: "Getting Started with Methylation-based Inference of Regulatory Activity"
author: "John Lawson"
date: "`r Sys.Date()`"
output: 
  BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{Getting Started with Methylation-based Inference of Regulatory Activity}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

# The MIRA Bioconductor package

*This vignette gives a broad overview of MIRA. You can find a realistic example workflow, in "Applying MIRA to a Biological Question."*

MIRA (Methylation-based Inference of Regulatory Activity) is an R package that infers regulatory activity from DNA methylation data. It does this by aggregating DNA methylation data from a set of regions across the genome, producing a single summary profile of DNA methylation for those regions. MIRA then uses this profile to produce a score (the MIRA score) that infers the level of regulatory activity on the basis of the shape of the DNA methylation profile. The region set is provided by the user and should contain regions that correspond to a shared feature, such as binding of a particular transcription factor or DNase hypersensitivity sites. The concept of MIRA relies on the observation that DNA methylation tends to be lower in regions where transcription factors are bound. Since DNA methylation will generally be lower in active regions, the shape of the MIRA profile and the associated score can be used as a metric to compare regulatory activity in different samples and conditions. MIRA thus allows one to predict transcription factor activity data given only DNA methylation data as input. MIRA works with genome-scale, single-nucleotide-resolution methylation data, such as reduced representation bisulfite sequencing (RRBS) or whole genome bisulfite sequencing (WGBS) data. MIRA overcomes sparsity in DNA methylation data by aggregating across many regions. Below are examples of methylation profiles and associated MIRA scores for two (contrived) samples. This vignette will demonstrate how to obtain a methylation profile and MIRA score from the starting inputs of DNA methylation data and a region set.

```{r, echo=FALSE, warning=FALSE}
library(MIRA)
data(exampleBins)
plotMIRAProfiles(exampleBins)
exScores <- calcMIRAScore(exampleBins, 
                    regionSetIDColName="featureID",
                    sampleIDColName="sampleName")
# normally sampleType would come from annotation object 
# but for this example we are manually adding sampleType column
sampleType <- c("Condition1", "Condition2")
exScores <- cbind(exScores, sampleType)
exScores
```

## Required inputs

You need 2 things to run MIRA:

1. Nucleotide-resolution DNA methylation data
2. A set of genomic regions

Let's describe each one in more detail:

### DNA methylation data

MIRA requires DNA methylation data after methylation calling. For a given genomic coordinate (the location of the C in a CpG), MIRA needs the methylation level (0 to 1) or data that can be used to calculate this: counts of methylated reads and total reads. The total number of reads can be used for screening purposes. This data should be represented as a `data.table` for each sample, which we call a BSDT (Bisulfite data.table). The BSDT will have these columns: `chr`, `start` (the coordinate of the C of the CpG) and the `methylProp` column with methylation level at each cytosine. Alternatively, the `methylProp` column may be generated from `methylCount` (number of methylated reads) and `coverage` (total number of reads covering this site) columns where `methylProp` = `methylCount`/`coverage` and these columns may be included in the `data.table` in addition to the `methylProp` column. When running MIRA on multiple samples, it is recommended to make each sample an item of a named list, with sample names as the names for the list. Since some existing R packages for DNA methylation use different formats, we include a format conversion function that can be used to convert `SummarizedExperiment`-based objects like you would obtain from the `bsseq`, `methylPipe`, and `BiSeq` packages to the necessary format for MIRA (`SummarizedExperimentToDataTable` function). A `BSseq` object is an acceptable input to MIRA and will be converted to the right format internally but for the sake of parallelization it is recommended that `BSseq` objects be converted to the right format outside the MIRA function so that MIRA can be run on each sample in parallel. Here is an example of a `data.table` in the right format for input to MIRA:

```{r}
data("exampleBSDT", package="MIRA")
head(exampleBSDT)
```

### Region sets
A region set is a GRanges object containing genomic regions that share a biological annotation. For example, it could be ChIP peaks for a transcription factor. Many types of region sets may be used with MIRA, including ChIP regions for transcription factors or histone modifications, promoters for a set of related genes, sites of motif matches, or DNase hypersensitivity sites. Many such region sets may be found in online repositories and we have pulled together some major sources at http://databio.org/regiondb. At the end of this vignette, we show how to load a database of regions with a few lines of code using the `LOLA` package. You may also want to check out [the `AnnotationHub` Bioconductor package](https://www.bioconductor.org/packages/release/bioc/html/AnnotationHub.html) which gives access to many region sets in an R-friendly format. For use in MIRA, each region set should be a GRanges object and multiple region sets may be passed to MIRA as a GRangesList with each list element being a region set. Here is an example of a region set, which we will use in this vignette:

```{r, message=FALSE}
data("exampleRegionSet", package="MIRA")
head(exampleRegionSet)
```

## Analysis workflow
The general workflow is as follows:  
1. Data inputs: start with single-nucleotide resolution methylation data and one or more sets of genomic regions, as described above.
2. Expand the regions sizes so that MIRA will be able to get a broad methylation profile surrounding your feature of interest. All regions should be expanded to the same final size.
3. Aggregate methylation data across regions to get a MIRA profile.
4. Calculate MIRA score based on shape of MIRA profile.

### The input
First let's load the necessary libraries and example data. `exampleBSDT` is a data.table containing genomic location, number of reads methylated (`methylCount`), and total read number (`coverage`) from bisulfite sequencing of a lymphoblastoid cell line. `exampleRegionSet` is a GRanges object with regions that share a biological annotation, in this case Nrf1 binding in a different lymphoblastoid cell line.

```{r, message=FALSE}
library(MIRA)
library(GenomicRanges) # for the `resize`, `width` functions
data("exampleRegionSet", package="MIRA")
data("exampleBSDT", package="MIRA")
```

While we only have one sample (`Gm06990_1`) in this example, we would normally want to have our samples in a named list so we will use that format here as well:

```{r}
BSDTList <- list(exampleBSDT)
names(BSDTList) <- "Gm06990_1"
```

Since our input methylation data did not have a column for proportion of methylation at each site (`methylProp`), we need to add this based on the methylation count and total coverage data.

```{r}
BSDTList <- addMethPropCol(BSDTList)
```

### Expand your regions

A short but important step. MIRA scores are based on the difference between methylation surrounding the regions versus the methylation at the region itself, so we need to expand our regions to include surrounding bases. Let's use the `resize` function from the `GenomicRanges` package to increase the size of our regions and make them all the same size. It is recommended to make all regions the same size so the final methylation profile will be easier to interpret. The average size of our regions is currently about 500:

```{r}
mean(width(exampleRegionSet))
```

For this vignette, 4000 bp regions should be wide enough to capture the dip:

```{r}
exampleRegionSet <- resize(exampleRegionSet, 4000, fix="center")
mean(width(exampleRegionSet))
```

Normally, we want to have each region set (only one in our case) be an item in a list, with corresponding names given to the list:

```{r}
exampleRegionSetGRL <- GRangesList(exampleRegionSet)
names(exampleRegionSetGRL) <- "lymphoblastoid_NRF1"
```

### Aggregating methylation across regions
Next we aggregate methylation across regions to get a summary methylation profile with the `aggregateMethyl` function. MIRA divides each region into bins, aggregates methylation levels for cytosines within a given bin for each region individually, and then aggregates matching bins over all the regions (all 1st bins together, 2nd bins together, etc.). A couple important parameters: The binNum argument determines how many approximately equally sized bins each region is split into. This could affect the resolution or noisiness of the MIRA profile because using more bins will result in smaller bin sizes (potentially increasing resolution) but also less reads per bin (potentially increasing noise). The minBaseCovPerBin argument in aggregateMethyl is used to screen out region sets that have any bins with less than a minimum coverage. Here we use the default (500). Let's aggregate the methylation and then view the MIRA profile.

```{r Aggregate_methylation, message=FALSE, warning=FALSE}
bigBin <- lapply(X=BSDTList, FUN=aggregateMethyl, GRList=exampleRegionSetGRL, 
                binNum=11)
bigBinDT <- bigBin[[1]]
```

We add the sample name to the data.table then plot the MIRA profile:

```{r Plot profiles, message=FALSE, warning=FALSE}
sampleName = rep(names(bigBin), nrow(bigBinDT))
bigBinDT = cbind(bigBinDT, sampleName)
plotMIRAProfiles(binnedRegDT=bigBinDT)
```

### Calculating the MIRA score
To calculate MIRA scores based on the MIRA profiles, we will apply the scoring function, `calcMIRAScore`, to the `data.table` that contains the methylation aggregated in bins. `calcMIRAScore` calculates a score for each group of bins corresponding to a sample and region set, based on the degree of the dip in the profile. With MIRA's default scoring method (`logratio`), `calcMIRAScore` will take the log of the ratio of the outside edges of the dip (identified by `calcMIRAScore`) to the center of the dip. Higher MIRA scores are associated with deeper dips. A flat MIRA profile would have a score of 0.

```{r Scoring, warning=FALSE}
sampleScores <- calcMIRAScore(bigBinDT,
                        regionSetIDColName="featureID",
                        sampleIDColName="sampleName")
head(sampleScores)
```

*A note on annotation*. For real uses of MIRA, samples and region sets should be annotated. In order to save memory, it is not recommended that sample name or sample type be included as columns in the BSDT before the aggregation step. An annotation file that matches sample name with sample type (`sampleType` column) can be used to add sample type information to the data.table after aggregating methylation. A sampleType column is not required for the main functions but is used for the plotting functions. See "Applying MIRA to a Biological Question" vignette for a workflow including annotation.

## Interpreting the results
Regulatory information can be inferred from the MIRA scores and profiles but interpretation depends on the type of region set and samples used. The basic assumption is that deeper dips and higher MIRA scores would be associated with generally higher activity at the regions that were tested, which might also inform you about the activity of the regulatory feature that defines the region set (eg the activity of a transcription factor if using ChIP-seq regions). However, MIRA does not directly tell you the activity of the regulatory feature and, in some cases, higher MIRA scores will not be associated with higher activity of the regulatory feature. For example, samples with higher MIRA scores for a transcription factor binding region set could have more activity of that transcription factor but there could be other causes like increased activity of a different transcription factor that binds to many of the same regions. Additionally, it is possible that the samples with higher scores generally had more similar chromatin states to the samples from which the region set was derived than samples with lower scores did (eg when using MIRA on samples from multiple tissue/cell types and the region set was derived from the same tissue/cell type as some but not all of the samples). The general interpretation rule is that a higher MIRA score means more activity but we encourage the user to think carefully about what biological question they are actually addressing based on the region sets and samples used. For more on interpreting the results, see the "Applying MIRA to a Biological Question" vignette.

## Bonus: Loading region sets with LOLA
Here is one simple way to get region sets to use with MIRA. First, download the LOLA Core Database (actual files, not the cached version) from [here](http://cloud.databio.org/regiondb/) (this might take a while). 
Next, let's load the `LOLA` package and use it to load some of the region sets into R!

The following code will not be evaluated because of the large files involved and long loading time but shows the general process (loading the almost 3,000 region sets could take 10-30 minutes). Alternatively to avoid the long loading process, you can just download the database and load region sets into R one by one with `data.table::fread` or another such function.
```{r, eval=FALSE}
library(LOLA)
pathToDB <- "path/to/LOLACore/hg38"
regionDB <- loadRegionDB(pathToDB)
```

The `regionDB` is a list that includes some annotation and a `GRangesList` of region sets that can be accessed with `regionDB$regionGRL`. Check out the `LOLA` docs [here](http://bioconductor.org/packages/release/bioc/html/LOLA.html) if you want some more information. Now you have plenty of region sets to use with MIRA!

---
title: "Applying MIRA to a Biological Question"
author: "John Lawson"
date: "`r Sys.Date()`"
output: 
  BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{Applying MIRA to a Biological Question}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

In this vignette, we show a more realistic MIRA workflow, including adding annotation and using multiple samples and region sets. Only the second half of this vignette is evaluated because of the large files involved.



# Biological Question
Ewing sarcoma is a pediatric cancer defined by the fusion oncoprotein EWS-FLI1, a transcription factor. We have DNA methylation data for Ewing sarcoma and muscle-related samples and we want to use this data to see if Ewing samples can be distinguished from muscle-related samples. We're also interested in exploring the regulatory activity of different genomic regions. MIRA can aggregate methylation from regions of interest across the genome which share some biological annotation (like transcription factor ChIP regions or DNase hypersensitivy sites (DHSs) for instance) in order to get a summary methylation profile for those regions. The MIRA package relies on the assumption that active genomic regions will tend to have lower DNA methylation levels due to binding of transcription factors and a more open chromatin state so the shape of the methylation profile contains information about the activity of those regions. You can infer differences between samples in the regulatory activity of those regions by comparing the profiles and associated scores (which are calculated based on the shape of the profiles). We will compare the Ewing samples to the muscle samples using MIRA with two region sets: first, Ewing-specific DHSs, and second, muscle-specific DHSs.

## Input:

This vignette requires large input files, which can be dowloaded here: [MIRA_Ewing_Vignette_Files.tgz](http://cloud.databio.org/vignettes/MIRA_Ewing_Vignette_Files.tar.gz). This archive contains:  

- Single-nucleotide resolution DNA methylation data (RRBS data) for 12 Ewing sarcoma samples and 12 myotube (muscle) samples recently analyzed in the paper [DNA methylation heterogeneity defines a disease spectrum in Ewing sarcoma](http://www.medical-epigenomics.org/papers/sheffield2017/).  
- Two sets of regions -- one with Ewing-specific DHSs and a one with muscle-specific DHSs, obtained from the [Regulatory Elements Database](http://db.databio.org/). All data is on the hg38 reference genome.

# Package workflow
  
Preparation: Start with appropriately formatted single-nucleotide resolution methylation data, region sets -- each with genomic regions corresponding to some biological annotation, and a sample annotation file that has sample name (sampleName column) and sample type (sampleType column). See `?SummarizedExperimentToDataTable` for options for converting formats from some other DNA methylation packages to our format.  
1. Do a quick run-through of the MIRA workflow with each region set with a few samples from each condition/sample type to make sure the region sizes are reasonable (discussed later).  
    1.1. Aggregate methylation data across regions to get a MIRA profile for each region set, sample combination.  
    1.2. Calculate MIRA score for each region set, sample combination based on the shape of the MIRA profile.  
2. Based on preliminary results, pick a region size for each region set depending on what the MIRA profiles look like.  
3. Run the full MIRA analysis with chosen region sizes.  
    3.1. Aggregate methylation data across regions to get a MIRA profile for each region set, sample combination.  
    3.2. Calculate MIRA score for each region set, sample combination based on the shape of the MIRA profile.  

## Initial Run-through

First, let's load the libraries and read in the data files. A sample annotation file was included with the package:

```{r, eval=TRUE, message=FALSE, warning=FALSE}
library(MIRA)
library(data.table) # for the functions: fread, setkey, merge
library(GenomicRanges) # for the functions: GRanges, resize
library(ggplot2) # for the function: ylab
exampleAnnoDT2 <- fread(system.file("extdata", "exampleAnnoDT2.txt", 
                                   package="MIRA")) 
```

Next, construct file names for the DNA methylation samples and the region sets (downloaded through the link in the `Input` section).

```{r, eval=FALSE}
# 12 Ewing samples: T1-T12
pathToData <- "/path/to/MIRA_Ewing_Vignette_Files/"
ewingFiles <- paste0(pathToData, "EWS_T", 1:12, ".bed")
# 12 muscle related samples, 3 of each type
muscleFiles <- c("Hsmm_", "Hsmmt_", "Hsmmfshd_","Hsmmtubefshd_")
muscleFiles <- paste0(pathToData, muscleFiles, rep(1:3, each=4), ".bed")
RRBSFiles <- c(ewingFiles, muscleFiles)
regionSetFiles <- paste0(pathToData, c("sknmc_specific.bed", "muscle_specific.bed"))
```

Let's read the files into R:

```{r, eval=FALSE}
BSDTList <- lapply(X=RRBSFiles, FUN=BSreadBiSeq)
regionSets <- lapply(X=regionSetFiles, FUN=fread)
```

We need to do a bit of preprocessing before we plug the data into MIRA. The `BSreadBiSeq` function reads DNA methylation calls from the software Biseqmethcalling, reading the methylation calls into `data.table` objects. We read in the region sets with `fread` so they will also be `data.table` objects. First, let's add sample names to the list of methylation `data.tables`. Then let's convert the region sets from `data.table` objects to `GRanges` objects, including chromosome, start, and end info. In most cases, strand information is not needed by MIRA and should be omitted. 

```{r, eval=FALSE}
names(BSDTList) <- tools::file_path_sans_ext(basename(RRBSFiles))
regionSets <- lapply(X=regionSets, 
                    FUN=function(x) setNames(x, c("chr", "start", "end")))
regionSets <- lapply(X=regionSets, FUN=
                        function(x) GRanges(seqnames=x$chr, 
                                              ranges=IRanges(x$start, x$end)))
```

We also need to pick initial region sizes. To get the methylation profile around our sites of interest, we are resizing the regions to 5000 bp. Also, using the same region size for all regions in a set will make the final methylation profile easier to interpret. This is a wide initial guess compared to the average region sizes for the region sets (around 151 bp for both region sets), but we will adjust this later on.

```{r, eval=FALSE}
regionSets[[1]] <- resize(regionSets[[1]], 5000, fix="center")
regionSets[[2]] <- resize(regionSets[[2]], 5000, fix="center")
names(regionSets) <- c("Ewing_Specific", "Muscle_Specific")
```

Now we are ready to run MIRA on a subset of the samples -- three Ewing and three muscle samples. First, we aggregate the methylation data into bins with `aggregateMethyl`. MIRA divides each region into bins and finds methylation that is contained in each bin in each region. Then matching bins are aggregated over all regions (all bin1's together, all bin2's together, etc.). The bin number (`binNum`) will affect the resolution or noisiness of the data -- a higher bin number will allow more resolution since each bin will correspond to a smaller genomic region but with the trade-off of possibly increasing noise due to less methylation data in each bin. An odd bin number is recommended for the sake of symmetry and MIRA scoring.

```{r, eval=FALSE}
subBSDTList <- BSDTList[c(1, 5, 9, 13, 17, 21)]
bigBin <- lapply(X=subBSDTList, FUN=aggregateMethyl, GRList=regionSets, 
                binNum=21, minBaseCovPerBin=0)
```

We then combine all samples into one `data.table` and add a column for sample name based on the names of the list items:

```{r, eval=FALSE}
bigBinDT1 <- rbindNamedList(bigBin, newColName = "sampleName")
```

If you are running the actual samples on your own device, you can skip the following step. Otherwise, let's load the binned methylation data (`bigBinDT1`) that would have been obtained by the previous step.

```{r, eval=TRUE}
# from data included with MIRA package
data(bigBinDT1)
```

Next we add on annotation data: the experimental condition or sample type for each sample. This is needed in order to group samples by sample type, which we will do when plotting the methylation profiles and MIRA scores. We will use functions from the `data.table` package to do this, merging based on the `sampleName` column.

```{r, eval=TRUE}
setkey(exampleAnnoDT2, sampleName)
setkey(bigBinDT1, sampleName)
bigBinDT1 <- merge(bigBinDT1, exampleAnnoDT2, all.x=TRUE)
```

Let's look at the MIRA profiles to see if we should change our region sizes.

```{r, eval=TRUE}
plotMIRAProfiles(binnedRegDT=bigBinDT1)
```

## Choosing Appropriate Region Sizes

While the methylation profiles look pretty good, the dips are a bit too narrow for the muscle-related samples when looking at the muscle-specific region set. The scoring function in MIRA could run into problems if the dips are too narrow since it expects the dips to be at least 5 bins wide from outside edge to outside edge (that number includes the outside edges). Let's use smaller region sizes for both region sets: 4000 bp for the Ewing DHS regions and 1750 bp for the muscle DHS regions (the choice is somewhat arbitrary). The size of the regions should not be decreased too much; if the regions are too small, there might be more noise since there would be less methylation data for each bin. Also, the regions must be wide enough to capture the outer edges of the dip since the outer edges are used for the MIRA score.

To implement our new region sizes:

```{r, eval=FALSE}
regionSets[[1]] <- resize(regionSets[[1]], 4000, fix="center") # Ewing
regionSets[[2]] <- resize(regionSets[[2]], 1750, fix="center") # muscle
```


## Full MIRA Analysis

Now we can run MIRA with all our samples. Let's aggregate methylation data again with `aggregateMethyl`.

```{r, eval=FALSE}
bigBin <- lapply(X=BSDTList, FUN=aggregateMethyl, GRList=regionSets, 
                binNum=21, minBaseCovPerBin=0)
bigBinDT2 <- rbindNamedList(bigBin)
```

If you are running the actual samples on your own device, you can skip the following step. Otherwise, let's load the binned methylation data (`bigBinDT2`) that would have been obtained by the previous step.

```{r, eval=TRUE}
# from data included with MIRA package
data(bigBinDT2)
```

We add annotation data using the same process as before:

```{r, eval=TRUE}
# data.table functions are used to add info from annotation object to bigBinDT2
setkey(exampleAnnoDT2, sampleName)
setkey(bigBinDT2, sampleName)
bigBinDT2 <- merge(bigBinDT2, exampleAnnoDT2, all.x=TRUE)
```

Let's look at the MIRA profiles:

```{r, eval=TRUE}
plotMIRAProfiles(binnedRegDT=bigBinDT2)
```

Next we normalize the binned methylation data (the MIRA profile). Normalizing by subtracting the minimum methylation bin value from each sample/region set combination generally brings the center MIRA profiles to a similar methylation value, making the MIRA score more about the shape of the profile and less about the average methylation. We do this with `data.table` syntax. 

```{r, eval=TRUE, results="hide"}
bigBinDT2[, methylProp := methylProp - min(methylProp) + .05, by=.(featureID, sampleName)]
```
```{r, eval=TRUE}
normPlot <- plotMIRAProfiles(binnedRegDT=bigBinDT2)
normPlot + ylab("Normalized DNA Methylation (%)")
```

Now we can calculate MIRA scores for all samples with the `calcMIRAScore` function.

```{r, eval=TRUE}
sampleScores <- calcMIRAScore(bigBinDT2,
                        shoulderShift="auto",
                        regionSetIDColName="featureID",
                        sampleIDColName="sampleName")
head(sampleScores)
```

Finally, let's add the annotation data back on and take a look at the scores!

```{r, eval=TRUE}
setkey(exampleAnnoDT2, sampleName)
setkey(sampleScores, sampleName)
sampleScores <- merge(sampleScores, exampleAnnoDT2, all.x=TRUE)
plotMIRAScores(sampleScores)
```

# Interpreting the Results
As expected, we found that the Ewing sarcoma samples had higher MIRA scores for the Ewing-specific DHSs, which implies more activity in Ewing-specific regions. The muscle-specific DHSs require more interpretation. The muscle samples on average had higher MIRA scores but there was not complete separation between the groups. This suggests that the Ewing samples still have some activity in muscle-specific regions. If we want to see whether differences between the groups are statistically significant, we can use, for example, the Wilcoxon rank sum test (a nonparametric parallel of the t test). First, we do this for the Ewing-specific region set.

```{r}
EwingSampleEwingRegions <- sampleScores[sampleScores$sampleType == "Ewing" &
                                           sampleScores$featureID ==
                                           "Ewing_Specific", ]
myoSampleEwingRegions <- sampleScores[sampleScores$sampleType == "Muscle-related" &
                                           sampleScores$featureID ==
                                           "Ewing_Specific", ]
wilcox.test(EwingSampleEwingRegions$score, myoSampleEwingRegions$score)
```

Next, we do it for the muscle-specific region set.

```{r}
EwingSampleMyoRegions <- sampleScores[sampleScores$sampleType == "Ewing" &
                                           sampleScores$featureID ==
                                           "Muscle_Specific", ]
myoSampleMyoRegions <- sampleScores[sampleScores$sampleType == "Muscle-related" &
                                           sampleScores$featureID ==
                                           "Muscle_Specific", ]
wilcox.test(EwingSampleMyoRegions$score, myoSampleMyoRegions$score)
```
We can see that the sample groups were significantly different for one region set (Ewing regions) but not the other (muscle regions). 

# General Interpretation Tips and Caveats
In general, interpretation will depend on the samples and region sets being used. While we have found MIRA useful for inferring regulatory activity of transcription factors, we must also remember that the MIRA score is only an indirect inference of activity of the TF. The methylation profile could be affected by other TFs aside from the TF of interest. Thus, it is possible that a sample could have a higher MIRA score for TF-binding regions than another sample yet still have less activity for that TF (but perhaps more activity for other regulatory elements that happen to also be in the same regions). With TF-binding region sets, what we are really measuring is simply that the regions where the TF binds have altered activity in one sample relative to another sample. The main thing to remember is that MIRA infers the general regulatory activity of the regions you give it and the biological interpretation depends on the samples and type of regions (biological annotation as well as the source tissue/cell type) you use.


# Other Tips for Using MIRA
When it comes to MIRA, lapply is your friend (although this is generally true anyway). This allows for distributed computing with `mclapply` (`parallel` package) or `bplapply` ([`BiocParallel` package](http://bioconductor.org/packages/release/bioc/html/BiocParallel.html)) if desired. 

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utility.R
\name{bsseqToDataTable}
\alias{bsseqToDataTable}
\title{Convert a BSseq object to data.table format for MIRA.}
\usage{
bsseqToDataTable(BSseqObj)
}
\arguments{
\item{BSseqObj}{An object of class BSseq, can have smoothed or raw
methylation data.}
}
\value{
MIRAFormatBSDTList A list of data.tables containing
the methylation data. One data.table per sample with the column
names: 'chr', 'start' (methylation coordinate), 'methylCount' (number of
methylated reads), 'coverage' (total number of reads), and 
'methylProp' (proportion of methylated reads). The order of the
list is the order of samples in the columns of the BSseq object.
If sample names are in the BSseq object, then a named list
will be returned.
}
\description{
Converts a BSseq object to a list of data.tables with one data.table
per sample. A wrapper of the SummarizedExperimentToDataTable function.
}
\examples{
data("exampleBSseqObj")
MIRAFormatBSDTList <- bsseqToDataTable(exampleBSseqObj)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotting.R
\name{plotMIRAScores}
\alias{plotMIRAScores}
\title{Plot MIRA scores and compare different conditions}
\usage{
plotMIRAScores(scoreDT, featID = unique(scoreDT[, featureID]),
  colBlindOption = FALSE)
}
\arguments{
\item{scoreDT}{A datatable with the following columns: 
score, featureID (names of region sets), ideally include 'sampleType'.}

\item{featID}{Region set name/names in a single string or vector of strings.}

\item{colBlindOption}{If TRUE, function will plot with a color blind
friendly palette which could be helpful when plotting multiple colors.}
}
\value{
a plot of class "gg"/"ggplot" that shows MIRA scores 
with geom_boxplot and geom_jitter (or geom_violin instead
of boxplot if no sampleType column is given).
}
\description{
Splits up samples by sample type. Displays each region set
in a different subplot.
If you only want to plot certain region sets,
subset with the `featID` parameter.
}
\details{
Due to the limited number
of colors in the palette, a warning will be issued if 
there are too many (more than 9) region sets ('featureID's).
}
\examples{
data(bigBinDT2)
exScores <- calcMIRAScore(bigBinDT2)
# adding annotation
sampleType <- rep(c("Ewing", "Muscle-related"), each = 24)
exScores <- cbind(exScores, sampleType)
exScorePlot <- plotMIRAScores(exScores)         
}

=pod

=encoding utf8

=head1 NAME

mira - static site generator

=head1 VERSION

This document describes L<mira> version B<00.07.55>.


=head1 Mira

integrated content management framework for create multiple websites.

A publishing tools for creat multiple static web sites

LL<https://metacpan.org/release/Mira>, Mira comes with a command-line application called C<mira> which you can use to create static websites.

 $ cpanm Mira # Install
 $ mira init                                  # Initialize current directory with new site
 $ mira new -t "post_title" -f "floor_name"   # creat new post
 $ mira build                                 # Build contents
 $ mira view                                  # serve locally at http://localhost:5000

B<Features>

=over

=item * Written in perl, available as a command line utility after installing.

=item * Content is written in many MarkUP languages.

=item * Layouts are developed using TT2 from the Template-toolkit templating engine.

=item * Configuration files and attributes are encoded with YAML.

=item * mira is a building, each directory in content folder is a floor, each floor is a separated site.

=item * each subdirectory in floors which start with _ is a static folder

=item * mira have a global config.yml in root

=item * each floor can have a config file in config directory: config/floor_name.yml

=back

=head1 Getting Started

The following sections show you how to install, upgrade, and downgrade the version of Mira you have, as well as how to use the C<mira> command-line utility and work with the directory structure it depends on.

=head2 Install

Install Mira in seconds:

 $ cpanm Mira

Then, create a new site, build it, and view it locally like so:

 $ mkdir new-site && cd new-site
 $ mira init
 $ mira -t "new post" -f blog
 $ Mira build
 $ Mira view

After that, browse to LL<http://localhost:5000> to see your site.

To modify the content, look at C<content/blog/yyyy-mm-dd-new_post.md>. you can change your content file name and extension, for wxample: C<content/blog/my_first_test_new_post.custom>

To modify the layout, edit C<template/default_theme/index.tt2>.

=head3 Upgrade

Find out which version of Mira you have, by using the C<-v> option:

 $ mira -v

You can compare this with the latest version from CPAN like this:

 $ cpan -D Mira

 ...
 ...
 Installed: 0.07.42
 CPAN:      0.07.47  Not up to date
 ...
 ...

In this example, you can see there is a newer version available. Upgrade like this:

 $ cpan Mira

Stable releases are available on CPAN, but development happens at LL<https://github.com/kiamazi/mira>. If you like living on the edge, install from the latest development tip like this:

 $ cpanm git://github.com/kiamazi/mira.git

=head3 Downgrade

If you want to install an older version of Mira, first find the link on
LL<http://backpan.perl.org/authors/id/K/KI/KIAVASH/mira/>. Then, install like
this (e.g. v0.07.39):

 $ cpanm http://backpan.perl.org/authors/id/K/KI/KIAVASH/mira/Mira-00.07.39.tar.gz

If you want, you can also install from source. To do that, you just need to download and unpack the desired release from LL<http://backpan.perl.org/authors/id/K/KI/KIAVASH/mira/>, or clone the repository from Github. Then, do this:

 $ perl Makefile.PL
 $ make
 $ make test
 $ make install

=head2 Usage

When you install the C<Mira> Perl module, an executable named C<mira> will be available to you in your terminal window.
You can use this executable in a number of ways. The following sections show you how.

=head3 Init

The C<mira init> command initializes a new site. Note that the site will be initialized in the current directory. Therefore, it's usually best to create a blank directory that can be used for this purpose. A description of the resulting directory structure is available in the
L<#directory-structure> section.

 # Initialize the current directory with a fresh skeleton of a site
 $ mira init

=head3 New

After the site has been initialized, create new post in blog floor using the C<mira new> command.

 $mira new -t "new post" -f blog

=head3 Build

After the site has been initialized, build it using the C<mira build> command. Mira takes care of reading the source files, combining them with the layout template(s), and saving the result in the C<public> directory.

 # Build the site
 $ mira build

=head3 View

The C<Mira view> command serves the contents of the C<public> directory using Mira's built-in webserver.

 # Serve the site locally at http://localhost:8000
 $ mira view

If you want to use a different port number (e.g. 9000) or different host address (e.g. 127.0.0.24), specifiy it using the I<-p> and I<-o> options:

 # Serve the site locally at http://localhost:9000
 $ mira view -p 9000 -o 127.0.0.24

=head2 Directory Structure

After running the L<#init> command, the following directory structure will be created:

 │
 ├── config
 ├── config.yml
 ├── content
 ├── public
 ├── statics
 ├── structure
 └── template

Here is a description of each file:

B<config.yml>

The configuration file is a LL<http://www.yaml.org/> file that specifies key configuration elements for your static websites. The default configuration file is as follows:

 # Mira configuration file
 ---
 title : My Sites
 ...
 ...
 ...

If you want to use another output directory, you may specify it in this file. For instance:

 # Mira configuration file
 ---
 title : My Site
 template: layout_name
 publishDIR: public
 output_extension: html    # output file extension
 default_extension: md     # new file extension

each floor can have them config or use config.yml by default, if you need a config file for blog, you can crate C<config/blog.yml>. publishDIR is only available in config.yml, but other config fields can use in general and public configs.

There are a few definitions that affect the way that Mira behaves. Those are defined in the L<#configuration> section. Those and any others that you choose to specify become available in the layout templates under the C<SITE> or C<MAIN> namespace. For instance, C<title> is available in templates like this:

 {{ SITE.name }}   # floor title saved in config/floor_name.yml
 {{ MAIN.title }}  # main title saved in config.yml

B<content>

all directories in content is a separated site. each file in this directories is a content:

defaut format for content file is like this:

 ---
 utid: 20170214184439
 date: 2017-02-14 18:44:39
 title: this is post title
 ---

 Hello world.

There are a few things to note about this file:

=over

=item 1. There is a YAML configuration block at the start of the file.

=item 2. the C<utid> configuration is master key of posts, all posts will be define and sort by this field.

=item 3. The C<title> configuration is the name of the post/page.

=item 4. All of the configurations may be used in the corresponding layout file.

<!-- Example use of "title" in a layout file -->
{{ post.title }}

=back

B<structure>

if you need custom post header for each floor, you can make a structure file in this folder:

structure/blog

 categories:
  -
 tags:
  -
 post_image:

B<template>

Layout files are processed using the TT2 from the Template-Toolkit template system. each folder in template is a separated template.

each template need this layouts:

 main.tt2
 index.tt2
 post.tt2
 archive.tt2
 atom.tt2

B<public>

The output file that is created is a mix of the input file and the template that is specified by the config file.

=head1 Configuration

Mira allows you to create static websites in just about any way that you want to. The project configuration files (C<config.yml> and C<config/floor_name.yml>) allows you to specify special instructions to Mira and also to guide the process of rendering the site using the source files (C<content/>) and the layout templates (C<template/layout_name>).

Variables specified in C<config.yml> and C<config> directory, are done using YAML.

=over

=item * B<description>

=item * B<ur>l

=item * B<root>

=item * B<static>

=item * B<imageurl>

=item * B<publishDIR>

default is 'public'

=item * B<post_num>

number or 'all'

=item * B<archive_post_num>

number or 'all'

=item * B<feed_post_num>

number or 'all'

=item * B<post_sort>

can set 'reverse'

=item * B<feed_output>

default is 'feed.xml'

=item * B<feed_template>

default is 'atom.tt2'

=item * B<default_floor>

if in new command dont use -f switch, mira use this field value for floor name

=item * B<permalink>

/:year/:month/:day/:FIELD_NAME/every_thing_else/:title .html or .php or .xhtnl or any extension you like

A full list of pattern options are as follows:

=item * B<default_markup>

=over

=item * markdown -or- md

=item * mmd   (mira markdown parser based on multimarkdown 2.0.b6)

=item * bbcode

=item * textile

=item * text -or- txt   just add C<< E<lt>brE<gt> >> in endlines

=item * html

=back

=item * B<default_extension>

default extension for new content files, default is md

=item * B<output_extension>

default extension for output files, default is html

=item * B<time_zone>

=item * B<t_start_tag>

template tag for use in theme, default is {{

=item * B<t_end_tag>

template tag for use in theme, default is }}

=item * B<t_outline_tag>

=item * B<feed_output>

default is feed.xml

=item * B<feed_template>

default is atom.tt2

=item * B<lists>

the fields you want make archive

=item * B<namespace> change lists static address

veryverylongarchivename : vlan      # /blog/tags/veryverylongarchivename  >   /blog/tags/vlan

=back

sample:

 title: my site
 url: http://myaddress.net/blog
 root: /blog

 lists:
  - date
  - tags

 links :
     Feed : http://feeds.feedburner.com/myfeed
     Amazon : http://amazon.com/author/name
     Github : http://github.com/name
     LinkedIn : http://linkedin.com/in/name
     Twitter : https://twitter.com/name

 socials:
  -  name: twitter
     url: https://twitter.com/UserName
     desc: Follow me on twitter

  -  name: github
     url: https://github.com/UserName
     desc: Fork me on twitter

  -  name: facebook
     url: https://facebook.com/UserName
     desc: Follow me on facebook

Any variable specified in C<configs> can be used in a template. MAIN for config.yml  and  SITE for config directory

 {{ SITE.title }}

URL can be used like this:

 <a href="{{ MAIN.url }}">{{ MAIN.title }}</a>

The links (key/value pairs) can be listed like this:

 {{ FOREACHEACH link in SITE.links }}
     <a href="{{ link.value }}">{{ link.key }}</a><br />
 {{ END }}

All of the items in the C<social> array can be shown like this:

 {{ FOREACHEACH social in SITE.socials }}
   <a href="{{ social.url }}">{{ social.name }} : {{ social.desc }}</a>
 {{- END }}

See the official LL<http://yaml.org/> specification.

=head1 content

content files in Mira are have 2 section, header and body.

 ---
 utid:
 title:
 ---
 content body

headers must contain LL<http://yaml.org/>.
The YAML at the beginning of the content files is denoted by leading and trailing lines that each contain a sequence of three dashes. Example:

 ---
 utid: 123456
 title: Post Title
 ---

 Here is the text of the post.

Variable definitions in headers that carry special meaning are as follows:

=over

=item * utid

master key of posts, dont edit it

=item * date

=item * title

=item * _index

change value for :title, if empty, title will be used for output name

=item * _permalink

defines the URL path for the output file just for this post. This may also be specified in C<config> as well.

=item * _type

default is post, but can set 'page'

=item * _markup

change body markup language just for this post

=item * selective personal fields like categories, tags, keywords, author and ...

=back

=head1 template

Layout templates in Mira are based on a superset of the LL<http://template-toolkit.org/> v2 (TT2).
Although both Mira and TemplateToolkit are both written in Perl, you do not need to know Perl in order to use them.

Layout templates include a series of directives. Directives can be used to print the contents of a variable, or perform more sophisticated computation such as if/then/else, foreach, or case statements. Directives are surrounded by matched pairs of hard brackets and percent signs. Here is an example of printing a variable called C<SITE.title>:

 {{ site.name }}

When printing variables, you may also use filters to transform the variable or print information about it. For instance, you can convert a variable name to all uppercase letters using the C<upper> filter. Example:

 {{ SITE.title | upper }}

Another class of "logic" directives are used in a similar fashion. Here is an example of a for statement that loops through each C<social> in C<SITE.social>. For each iteration of the loop, print the contents of C<social.name>:

 {{ FOREACHEACH social in SITE.socials }}
   {{ social.name }}
 {{ END }}

The following sections show how to use directives in more depth.

=head2 Variables

This section describes how to use variables, literals, and expressions in Mira.

Variables are bits of text or numbers that are defined in the project configuration file or in the source files that can be used in templates. Here is an example of printing the contents of C<post.title>:

 {{ post.title }}

In Mira, there are two top-level variables (think of them as namespaces), which are C<SITE>-C<MAIN> and C<POSTS>. All C<SITE> variables are defined in C<config/floor_name.yml>, and C<MAIN> variables are defined in C<config.yml> and are available in layouts as C<{{ SITE.* }}> and C<{{ MAIN.* }}>. All page variables (defined at the beginning of source files) are available in
layouts as C<{{FOREACH post in POSTS}}{{ posts.* }}{{ END }}> for index and archives and C<{{ post.* }}> for post.tt2.

Example C<config/blog.yml>:

 title: main site title

Example C<content/blog/sample_post.md>:

 ---
 utid: 123456
 title: The title of my post
 ---
 less body
 <!-- more -->
 The body of my post.

Example C<template/my_layout/post.tt2>:

 <html>
 <head>
     <title>{{ post.title }} - {{ SITE.title }}</title>
 </head>
 <body>
     <h1>{{ post.title }}</h1>
     <p>{{ post.body.more }}</p>
 </body>
 </html>

This would produce the following:

 <html>
 <head>
     <title>The title of my post - site title</title>
 </head>
 <body>
     <h1>The title of my post</h1>
     <p>less body</p>
     <p>The body of my post.</p>
 </body>
 </html>

Variables can also be defined within a template file. For example:

 {{ a = 42 }}{{ a }}
 {{ b = "Hello" }}{{ b }}

Result:

 42
 Hello

It's also possible to create arrays:

 {{ a = [1, 2, 3, 4, 5] }}
 {{ a.1 }}
 {{ a | length }}

Result:

 2
 5

And associative arrays (hashes):

 {{ link = {name => 'ma name', 'url' => 'http://myaddress.com/'} }}
 <a href="{{ link.url }}">{{ link.name }}</a>

Result:

 <a href="http://myaddress.com/">my name</a>

I<Literals>

The following are the types of literals (numbers and strings) allowed in
layouts:

 {{ 23423 }}          Prints an integer
 {{ 3.14159 }}        Prints a number
 {{ pi = 3.14159 }}   Sets the value of the variable
 {{ 3.13159.length }} Prints 7 (the string length of the number)

I<Expressions>

Expressions are one or more variables or literals joined together with operators. An expression can be used anywhere a variable can be used with the exception of the left-hand side of a variable assignment directive or a filename for one of the C<process>, C<include>, C<wrapper>, or C<insert>
directives.

Examples:

 {{ 1 + 2 }}       Prints 3
 {{ 1 + 2 * 3 }}   Prints 7
 {{ (1 + 2) * 3 }} Prints 9

 {{ x = 2 }}       Assignments don't return anything
 {{ (x = 2) }}     Unless they are in parens. Prints 2
 {{ y = 3 }}
 {{ x * (y - 1) }} Prints 4

For a full listing of operators, see
LL<http://template-toolkit.org>.

=head2 Conditionals

Conditional statements are possible in Mira. A variety of options exist, including C<if/else>, C<unless>, and C<switch/case>, which are defined next.

=head3 IF/ELSE

C<IF> statements are used for controlling the flow of execution through a layout template. C<IF> statements take an expression. If true, the proceeding block is executed. If not, an C<ELSIF> block is executed (if it exists). Finally, an C<ELSE> block (if it exists) is executed if neither the C<IF> or the C<ELSIF> block is true. Example:

Here is an if/else example:

 {{ IF post.category == "books" }}
     Category: Books
 {{ ELSIF post.category == "movies" }}
     Category: Movies
 {{ ELSE }}
     Category: Unknown
 {{ END }}

For brevity, C<IF> statements may also be used as post-operative directives.
Example:

 {{ "Category: Books" IF post.category == "books" }}

=head3 UNLESS

Same as C<IF> statements, but the condition is reversed. The following block is only evaluated if the expression is I<not> true.

 {{ UNLESS post.category == "books" }}
     Category: (Not) Books
 {{ END }}

C<Unless> directives can also be used as post-operative directives. Example:

 {{ "Category: (Not) Books" UNLESS post.category == "books" }}

=head3 Switch/Case

Switch statements are allowed in Mira as well. Usage is best described with an example:

 {{ SWITCH post.category }}
     {{ case "books"  }} Category: Books
     {{ case "movies" }} Category: Movies
     {{ case default  }} Category: Unknown
 {{ END }}

=head2 Iteration

Iterative (looping) constructs are also available in Mira. Options include C<foreach>, and C<while>. Additionally, a C<loop> variable is provided to allow you to see information about the current loop.

=head3 FOREACH

C<Foreach> statements allow you to iterate over the contents of an array. If the variable is not already an array, it is automatically converted to an array for you. Example:

 {{ FOREACHEACH link IN SITE.blogroll }}
     The link is {{ link }}
 {{ END }}

You can also use C<=> in place of C<in>:

 {{ FOREACHEACH link = site.blogroll }}
     The link is {{ link }}
 {{ END }}

The C<foreach> statement also works on hashes:

 {{ FOREACHEACH [{a => 1}, {a => 2}] }}
     Key a = {{ a }}
 {{~ END }}

Result:

     Key a = 1
     Key a = 2

During a C<foreach> loop, a special variable called C<loop> is available and provides
the following information:

Variable         | Definition
-----------------|-------------------------------------------------------------
C<loop.index>     | The current index
C<loop.max>       | The max index of the list
C<loop.size>      | The number of items in the list
C<loop.count>     | Index + 1
C<loop.number>    | Index + 1
C<loop.first>     | True if on the first item
C<loop.last>      | True if on the last item
C<loop.next>      | Return the next item in the list
C<loop.prev>      | Return the previous item in the list
C<loop.odd>       | Return 1 if the current count is odd, 0 otherwise
C<loop.even>      | Return 1 if the current count is even, 0 otherwise
C<loop.parity>    | Return "odd" if the current count is odd, "even" otherwise

Example:

 {{ FOREACHEACH [1 .. 3] }}
     {{ loop.count }}/{{ loop.size }}
 {{ END }}

Result:

 1/3
 2/3
 3/3

Additinoally, C<break/last> and C<next> directives may be used in loops. C<Break> is an alias for C<last> and exits the loop. C<Next> skips the remainder of the current loop and begins the next iteration in the loop. Example:

 {{ FOREACHEACH [1 .. 3] }}
     {{ IF loop.count == 2 }}{{ BREAK }}{{ END }}
     {{ loop.count }}/{{ loop.size }}
 {{ END }}

Result:

 1/3

Example:

 {{ FOREACH [1 .. 3] }}
     {{ IF loop.count == 2 }}{{ NEXT }}{{ END }}
     {{ loop.count }}/{{ loop.size }}
 {{ END }}

Result:

 1/3
 3/3

=head3 While

The C<while> directive will process a block of code while a condition continues
to be true. Example:

 {{ i = 0 }}
 {{ while i < 3 }}
     {{ i = i + 1 }}
     i = {{ i }}
 {{ END }}
 #>

Result:

 i = 1
 i = 2
 i = 3

As with C<foreach> statements, C<break/last> and C<next> statements are also available.

=head2 BLOCK

C<Block> directives allow you to save a block of text under a name for later use in an C<include> directive. Blocks may be placed anywhere within the template being processed. Example:

 {{ BLOCK foo }}Some text{{ END }}
 {{ INCLUDE foo }}

=head2 Includes

An C<include> directive parses the contents of a file or C<block> and inserts them into the template. Variables that are defined or modified within the included bits are discarded after the include occurs. Example:

 {{ INCLUDE "path/to/template.tt2" }}

 {{ file = "path/to/template.html" }}
 {{ INCLUDE $file }}

 {{ BLOCK foo }}This is foo{{ END }}
 {{ INCLUDE foo }}

Arguments may also be passed to the template:

 {{ INCLUDE "path/to/template.tt2" a = "An arg" b = "Another arg" }}

Multiple filenames can be passed by separating them with a plus, a space, or commas. Any supplied arguments will be used on all templates. Example:

 {{ INCLUDE "path/to/template1.tt2",
            "path/to/template2.tt2" a = "An arg" b = "Another arg" }}

=head3 Date

The Date plugin provides an easy way to generate formatted time and date strings by delegating to the POSIX strftime() routine.

The plugin can be loaded via the C<use> directive.

 {{ USE date }}

This creates a plugin object with the default name of C<date>. An alternate name can be specified like this:

 {{ USE myname = date }}

The plugin provides the format() method which accepts a time value, a format string and a locale name. All of these parameters are optional with the current system time, default format ('%H:%M:%S %d-%b-%Y') and current locale being used respectively, if undefined. Default values for the time, format and/or locale may be specified as named parameters in the use directive.

 {{ USE date(format = '%a %d-%b-%Y', locale = 'fr_FR') }}

When called without any parameters, the format() method returns a string representing the current system time, formatted by strftime() according to the default format and for the default locale (which may not be the current one, if locale is set in the use directive).

 {{ date.format }}

The plugin allows a time/date to be specified as seconds since the epoch, as is returned by time().

 File last modified: {{ date.format(filemod_time) }}

The time/date can also be specified as a string of the form C<h:m:s d/m/y> or C<y/m/d h:m:s>. Any of the characters C<:> C</> C<-> or space may be used to delimit fields.

 {{ USE day = date(format => '%A', locale => 'en_GB') }}
 {{ day.format('4:20:00 9-13-2000') }}

Output:

 Tuesday

A format string can also be passed to the format() method, and a locale specification may follow that.

 {{ date.format(filemod, '%d-%b-%Y') }}
 {{ date.format(filemod, '%d-%b-%Y', 'en_GB') }}

A fourth parameter allows you to force output in GMT, in the case of seconds-since-the-epoch input:

 {{ date.format(filemod, '%d-%b-%Y', 'en_GB', 1) }}

Note that in this case, if the local time is not GMT, then also specifying '%Z' (time zone) in the format parameter will lead to an extremely misleading result.

Any or all of these parameters may be named. Positional parameters should always be in the order ($time, $format, $locale).

 {{ date.format(format => '%H:%M:%S') }}
 {{ date.format(time => filemod, format => '%H:%M:%S') }}
 {{ date.format(mytime, format => '%H:%M:%S') }}
 {{ date.format(mytime, format => '%H:%M:%S', locale => 'fr_FR') }}
 {{ date.format(mytime, format => '%H:%M:%S', gmt => 1) }}
 ...etc...

The now() method returns the current system time in seconds since the epoch.

 {{ date.format(date.now, '%A') }}

The calc() method can be used to create an interface to the Date::Calc module (if installed on your system).

 {{ calc = date.calc }}
 {{ calc.Monday_of_Week(22, 2001).join('/') }}

The manip() method can be used to create an interface to the Date::Manip module (if installed on your system).

 {{ manip = date.manip }}
 {{ manip.UnixDate("Noon Yesterday","%Y %b %d %H:%M") }}

=head2 Chomping

When using directives in templates, it can help to add whitespace around the directives to make them more readable. However, adding this whitespace can make the resulting output unreadable. To help with this, special uses of the C<+>, C<->, C<=>, and C<~> characters can be used to pre- and post-chomp the whitespace as follows:

=head4 {{+ Chomp None +}}

Don't do any chomping.

 Quick.

 {{+ "Brown." +}}

 Fox.

Result:

 Quick.

 Brown.

 Fox.

=head4 {{- Chomp One -}}

Delete any whitespace up to the adjacent newline.

 Quick.

 {{- "Brown." -}}

 Fox.

Result:

 Quick.
 Brown.
 Fox.

=head4 {{~ Chomp Greedy ~}}

Remove all adjacent whitespace.

 Quick.

 {{~ "Brown." ~}}

 Fox.

Result:

 Quick.Brown.Fox.

=head2 Github Pages

Github Pages is a free service that allows you to publish a static website for free. By pushing your changes to a git repository, your website will be automatically available on github.io. Here are the steps:

=over

=item 1. First, if you don’t have an account already, you should sign up for a LLL<http://github.com/>.

=item 2. Next, create a new repository named C<< E<lt>usernameE<gt>.github.io >> where you should replace C<< E<lt>usernameE<gt> >> with your actual Github username.

=item 3. After that, push the contents of your C<_output> directory to the new github repo. Steps:

   $ cd public
   $ git init
   $ git remote add origin https://github.com/<username>/<username>.github.io.git
   $ git add *
   $ git commit -m"Initial revision"
   $ git push

=item 4. Wait a few minutes. Then, find your new website on github.io at the following
address: C<< http://E<lt>usernameE<gt>.github.io >>.

=back

=head1 Author

Mira was written by Kiavash Mazi
LL<mailto:kiavash@cpan.org>.

=head1 License and Copyright

mira is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program. If not, see LL<http://www.gnu.org/licenses/>.

=cut

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{exampleBins}
\alias{exampleBins}
\title{A data.table with artificial binned methylation data}
\format{A data.table, data.frame object}
\usage{
data(exampleBins)
}
\description{
Artificial data for two samples/conditions.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{exampleAnnoDT1}
\alias{exampleAnnoDT1}
\title{A data.table with annotation for a bisulfite sample.}
\format{A data.table, data.frame object}
\usage{
data(exampleAnnoDT1)
}
\description{
Has columns for name and sample type.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utility.R
\name{rbindNamedList}
\alias{rbindNamedList}
\title{Combine data.tables from a named list into one big data.table with extra
column for name.}
\usage{
rbindNamedList(namedList, newColName = "sampleName")
}
\arguments{
\item{namedList}{A list of data.tables. One sample per data.table/list item.
Names of the list are the sample names.}

\item{newColName}{The name of the column that will be added to the data.tables}
}
\value{
mergedDT A single data.table that combines those in the input list 
(data.table::rbindlist)
but also added a column (default, newColName="sampleName") to each one to
keep track of which rows were from which sample
}
\description{
Combines data.tables from a list as data.table::rbindlist except an 
extra column is added which can mark which rows came from which 
original data.table. The name of this new column can be 
specified (newColName param) and the values are the names of the input list.
This function was originally intended for a list where each
data.table corresponds to a separate sample and the list names
correspond to the names of the samples. Now all samples can
be combined into one data.table but which sample the information
came from can be kept.
}
\examples{
# NOTE: generally sample names should be added after running aggregateMethyl() 
# rather than before in order to save memory (since data.table has less rows
# after aggregation)
data(exampleBSseqObj)
multiSampleList <- bsseqToDataTable(exampleBSseqObj)
combinedDT <- rbindNamedList(multiSampleList)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{exampleBSseqObj}
\alias{exampleBSseqObj}
\title{A small BSseq object.}
\format{A BSseq object}
\usage{
data(exampleBSseqObj)
}
\description{
A BSseq object which has the top 20 rows of the BSseq object "BS.chr22"
which was included as built-in data in the bsseq package
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/binning_aggregation.R
\name{BSBinAggregate}
\alias{BSBinAggregate}
\title{Bins regions and aggregates methylation data across the regions by bin}
\usage{
BSBinAggregate(BSDT, rangeDT, binNum, minBaseCovPerBin = 500,
  byRegionGroup = TRUE, splitFactor = NULL, hasCoverage = TRUE)
}
\arguments{
\item{BSDT}{A single data table that has DNA methylation data 
on individual sites including a "chr" column with chromosome, 
a "start" column with the coordinate number for the cytosine, 
a "methylProp" column with proportion of methylation (0 to 1), 
optionally a "methylCount" column with number of 
methylated reads for each site, and 
optionally a "coverage" column with total number of reads for each site
(hasCoverage param).}

\item{rangeDT}{A data table with the sets of regions to be binned, 
with columns named "start", "end". Strand may also be given and will
affect the output. See "Value" section.}

\item{binNum}{Number of bins across the region.}

\item{minBaseCovPerBin}{Filter out bins where the sum of coverage values is
less than X before returning.}

\item{byRegionGroup}{Default TRUE will aggregate methylation over 
corresponding bins for each region (all bin1's aggregated, all bin2's, etc).
byRegionGroup = FALSE is deprecated.}

\item{splitFactor}{With default NULL, aggregation will be done 
separately/individually for each sample.}

\item{hasCoverage}{Default TRUE. Whether there is a coverage column}
}
\value{
With splitFactor = NULL, it will return a data.table 
with binNum rows, 
containing aggregated methylation data over regions in region set "rangeDT".
Each region was split into bins; methylation was put in these bins; 
Output contains sum of the all corresponding bins 
for the regions of each region set ie for all regions in each region set: 
first bins summed, second bins summed, etc.
Columns of the output should be "bin", "methylProp", and, if
coverage was included as input col, "coverage"

Info about how strand of rangeDT affects output:
The MIRA profile will be symmetrical if no strand information is given for 
the regions (produced by averaging the profile with the reverse of the 
profile), because the orientation of the regions is arbitrary with respect 
to biological features (like a promoter for instance) that could be 
oriented directionally (e.g. 5' to 3'). If strand information is given, 
regions on the minus strand will be flipped before being aggregated 
with plus strand regions so the MIRA profile will be in 
5' to 3' orientation.
}
\description{
First bins regions and averages the proportion of methylation for
all methylation sites within each bin (ie  the methylation of 
all sites within region 1, bin 1 are averaged, then all sites 
within region 1, bin 2 are averaged, etc.)
Then aggregates methylation across all regions by bin by averaging
the proportion of methylation in each corresponding 
bin (ie all bin1's together, all bin2's together, etc.).
}
\examples{
data("exampleBSDT") # exampleBSDT
data("exampleRegionSet") # exampleRegionSet
exampleBSDT <- addMethPropCol(exampleBSDT)
aggregateBins <- BSBinAggregate(BSDT = exampleBSDT, 
                             rangeDT = exampleRegionSet, 
                             binNum = 11, splitFactor = NULL)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{exampleBSDT}
\alias{exampleBSDT}
\title{A data.table containing DNA methylation data.}
\format{A data.table, data.frame object}
\usage{
data(exampleBSDT)
}
\description{
This object contains reduced
representation bisulfite sequencing data from the
GM06990 B-lymphoblastoid cell line that was generated by the ENCODE
project (GEO accession GSE27584, sample GSM980583). Has columns for
position (chr, start), number methylated reads, and number of reads total.
The sample name is Gm06990_1.
Only a subset of the full data is used in this object and the 
data was switched from hg19 to hg38.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MIRA.R
\name{calcMIRAScore}
\alias{calcMIRAScore}
\title{Score methylation profile based on its shape}
\usage{
calcMIRAScore(binnedDT, shoulderShift = "auto", method = "logRatio",
  usedStrand = FALSE, regionSetIDColName = "featureID",
  sampleIDColName = "sampleName")
}
\arguments{
\item{binnedDT}{A data.table with columns for:
bin ("bin"), methylation level ("methylProp"), 
region set ID/name (default expected column name is "featureID" 
but this is configurable via a parameter), sample name (default expected column name is 
"sampleName" but this is configurable via a parameter). 
The bin column is not used for calculations since it is assumed by
the function that the rows will be in the order of the bins (so the
function will work without a bin column although the bin column assists
in human readability of the input data.table)}

\item{shoulderShift}{Used to determine the number of bins away from the 
center to use as the shoulders. Default value "auto" optimizes the 
shoulderShift variable for each sample/region set combination to try find the 
outside edges of the dip. shoulderShift may be manually set as an integer
that will be used for all sample/region set combinations. "auto" does not 
currently work with region sets that include strand info.

Brief description/example of the algorithm for "auto": for concave up MIRA
profiles with an odd number of bins, the first potential shoulder 
will be the 2nd bin from the center (if the center was 0). This is
the first bin that could not be included in center methylation value for 
scoring. From there, the shoulder will be changed to the next bin towards
the outside of the profile if the next bin over has a higher methylation
value or if the average methylation value of the next two bins are 
higher than the methylation value of the current shoulder bin. The 
potential shoulder bin keeps moving outward toward the edges of the MIRA
profile until neither of these conditions are met and whatever
bin it stops on is used for the shoulder in the MIRA
score calculation. For symmetrical MIRA profiles (the general use case),
the shoulders picked on both sides of the center will be the same number of 
bins away from the center bin (symmetrical shoulders).}

\item{method}{The scoring method. "logRatio" is the log of the ratio of outer
edges to the middle. This ratio is the average of outside values 
of the dip (shoulders) divided by either the center value if 
it is lower than the two surrounding values (lower for concave up profiles or
higher for concave down profiles) or if it is not lower (higher for
concave down profiles), an 
average of the three middle values. For an even binNum, the middle four
values would be averaged with the 1st and 4th being weighted by half (as
if there were 3 values). 
A higher score with "logRatio" corresponds to a deeper dip. "logRatio" is the
only scoring method currently but more methods may be added in the future.}

\item{usedStrand}{If strand information is included as part of an
input region set when aggregating methylation, 
the MIRA profile will probably not be 
symmetrical. In this case, the automatic 
shoulderShift sensing (done when shoulderShift="auto") needs to
be done for both sides of the dip instead of just one side so set
usedStrand=TRUE if strand was included for a region set.
usedStrand=TRUE only has an effect on the function when shoulderShift="auto".}

\item{regionSetIDColName}{A character object. The name of the column
that has region set names/identifiers.}

\item{sampleIDColName}{A character object. The name of 
the column that has sample names/identifiers.}
}
\value{
A data.table with a column for region set ID 
(default name is featureID), sample ID (default name is sampleName), 
and MIRA score (with name "score"). There will
be one row and MIRA score for each sample/region set combination.
The MIRA score quantifies the "dip" of 
the MIRA profile which is an aggregation of methylation 
over all regions in a region set.
}
\description{
This will take a data.table
that has the methylation level in each bin in the MIRA profile and
return a single score. For the "logRatio" method, this score summarizes 
how large the 'dip' 
in methylation is at the center of that methylation profile.
A column for sample ID/name and a column for region set ID/name
should be included in the data.table because a separate score will be given 
for each sample/region set combination.
 
See `method` parameter for details on scoring calculations.
}
\examples{
data("exampleBins")
calcMIRAScore(exampleBins)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MIRA.R
\name{aggregateMethyl}
\alias{aggregateMethyl}
\title{Aggregate methylation data to get
a summary methylation profile for each region set}
\usage{
aggregateMethyl(BSDT, GRList, binNum = 11, minBaseCovPerBin = 500)
}
\arguments{
\item{BSDT}{A single data.table that has DNA methylation data on individual 
sites. Alternatively a BSseq object is allowed which will be converted 
internally to data.tables. The data.table input should have columns:
"chr" for chromosome, "start" for 
cytosine coordinate, "methylProp" for proportion of 
methylation (0 to 1), optionally "methylCount" 
for number of methylated reads, and
optionally "coverage" for total number of reads.}

\item{GRList}{A GRangesList object containing region sets, each set 
corresponding to a type of regulatory element. 
Each region set in the list should
be named. A named list of data.tables also works.}

\item{binNum}{How many bins each region should be split into for aggregation 
of the DNA methylation data.}

\item{minBaseCovPerBin}{Screen out region sets that have any bins in the
final methylation profile with 'sumCoverage' below the 'minBaseCovPerBin'
threshold. 'sumCoverage' is an output column: during aggregation, 
the 'coverage' values for each base in a bin are added, then these sums
are added for corresponding bins from all regions, producing a 
'sumCoverage' value for each bin. 'minBaseCovPerBin' is only 
used if there is a "coverage" column in the input methylation data.table.
'sumCoverage' is greater than or equal to the number of separate reads
that contributed to a given bin.}
}
\value{
a data.table with binNum rows for each region set containing
aggregated methylation data. If the input was a BSseq object
with multiple samples, a list of data.tables will be returned with
one data.table for each sample.
Each region was split into bins; methylation was put in these bins; 
Output contains sum of the all corresponding bins for the regions of each 
region set, ie for all regions in each region set: first bins summed, second 
bins summed, etc. Columns of the output should be "bin", "methylProp", 
"sumCoverage" (only if coverage was an input column, described below),
"featureID" (ID for 
the region set).
For information on symmetry of bins and output when a region set has
strand info, see ?BSBinAggregate.
'sumCoverage' is calculated as follows: during aggregation, 
the 'coverage' values for each base in a bin are added, then these sums
are added for corresponding bins from all regions, producing a 
'sumCoverage' value for each bin.
}
\description{
The main function for aggregating methylation data in MIRA analysis. 
Aggregates methylation across all regions in a given region set to
give a summary methylation profile for each region set.
}
\details{
Each region is split into bins. For a given set of regions, 
methylation is first aggregated (averaged) within each 
bin in each region. Then methylation from corresponding bins from each
region are aggregated (averaged) across all regions 
(all first bins together, all second bins together, etc.), 
giving an aggregate methylation profile.
This process is done for each region set.
}
\examples{
data("exampleBSDT", package = "MIRA")
data("exampleRegionSet", package = "MIRA")
exBinDT <- aggregateMethyl(exampleBSDT, exampleRegionSet)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/binning_aggregation.R
\name{binRegion}
\alias{binRegion}
\title{Divide region into similarly sized bins.}
\usage{
binRegion(start, end, bins, idDF = NULL, strand = "*")
}
\arguments{
\item{start}{Coordinate for beginning of range/range.}

\item{end}{Coordinate for end of range/region.}

\item{bins}{How many bins to divide this range/region.}

\item{idDF}{A string/vector of strings that has chromosome (e.g. "chr1") 
for given start and end values}

\item{strand}{"strand" column of the data.table (or single
strand value if binRegion is only used on one region). Default is "*".}
}
\value{
A data.table, expanded to nrow = number of bins, with these id columns:
     id: region ID
     binID: repeating ID (this is the value to aggregate across)
     ubinID: unique bin IDs
}
\description{
Given a start, end, and number of bins, to divide, 
this function will split the regions into bins.
Bins will be only approximately the same size, due to rounding.
(they should not be more than 1 different).
}
\details{
Use case: take a set of regions, like CG islands, and bin them; now you can
aggregate signal scores across the bins, giving you an aggregate signal
in bins across many regions of the same type.

In theory, this just runs on 3 values, but you can run it inside a 
data.table j expression to divide a bunch of regions in the same way.
}
\examples{
library(data.table)
start <- c(100, 1000, 3000)
end <- c(500, 1400, 3400)
chr <- c("chr1", "chr1", "chr2")
strand <- c("*", "*", "*")
# strand not included in object 
# since MIRA assumes "*" already unless given something else
regionsToBinDT <- data.table(chr, start, end)
numberOfBins <- 15
# data.table "j command" using column names and numberOfBins variable
binnedRegionDT <- regionsToBinDT[, binRegion(start, end, numberOfBins, chr)]
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{exampleAnnoDT2}
\alias{exampleAnnoDT2}
\title{Annotation data for the "Applying MIRA to a 
Biological Question" vignette.}
\format{A data.table, data.frame object}
\usage{
data(exampleAnnoDT2)
}
\description{
A data.table with annotation data (sampleName
and sampleType columns) for 24 Ewing samples and 24 muscle-related
samples (human skeletal myoblasts and other related samples).
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utility.R
\name{SummarizedExperimentToDataTable}
\alias{SummarizedExperimentToDataTable}
\title{Make MIRA-compatible data.tables using information 
from SummarizedExperiment-based classes}
\usage{
SummarizedExperimentToDataTable(coordinates, methylCountDF = NULL,
  coverageDF = NULL, methylPropDF = NULL, sample_names = NULL)
}
\arguments{
\item{coordinates}{Coordinates for the methylation loci as a GRanges 
(or GPos) object (in same order as methylCountDF/coverageDF/methylPropDF, 
whichever is given).
The start coordinate should be the coordinate of the cytosine.}

\item{methylCountDF}{An object of matrix/data.frame/similar format
that contains the number of reads with methylated C's for the loci in
'coordinates' argument. It should have one column per sample with
rows that correspond to 'coordinates'.}

\item{coverageDF}{An object of matrix/data.frame/similar format
that contains the total number of reads for the loci in
'coordinates' argument. It should have one column per sample with
rows that correspond to 'coordinates'.}

\item{methylPropDF}{An object of matrix/data.frame/similar format
that contains the total number of reads for the loci in
'coordinates' argument. It should have one column per sample with
rows that correspond to 'coordinates'.}

\item{sample_names}{A character vector with sample names in the same
order as the columns of methylCountDF/coverageDF/methylPropDF
samples in the columns}
}
\value{
MIRAFormatBSDTList A list of data.tables containing
the methylation data. One data.table per sample with the column
names: 'chr', 'start' (methylation coordinate), 'methylCount' (number of
methylated reads), 'coverage' (total number of reads), and 
'methylProp' (proportion of methylated reads). The order of the
list is the order of samples in the columns of 
methylCountDF/coverageDF/methylPropDF. If sample names 
are explicitly given as input ('sample_names' argument)
or can be derived from other arguments to the function then
a named list will be returned.
}
\description{
Packages that use SummarizedExperiment-based classes for DNA methylation
data which could be converted with this function 
include "bsseq", "methylPipe", and "BiSeq" packages. 
Of the methylCountDF, coverageDF, and methylPropDF arguments, either 
methylPropDF must be given or both methylCountDF and coverageDF must
be given. After that, whichever is not given will be calculated 
from the others. If coverageDF and methylCountDF are both not given,
coverage will be assumed to be 1 at each site with a methylProp value.
Acceptable formats for the three "DF" parameters include:
data.frame, data.table, matrix, and DelayedMatrix classes.
If converting a BSseq object, see ?bsseqToDataTable for a convenient
wrapper of this function.
}
\examples{
 
data("exampleBSseqObj")
MIRAFormatBSDTList <- SummarizedExperimentToDataTable(coordinates = 
    bsseq::granges(exampleBSseqObj), 
    methylCountDF = bsseq::getCoverage(BSseq = exampleBSseqObj, type = "M"), 
    coverageDF = bsseq::getCoverage(BSseq = exampleBSseqObj, type = "Cov"),
    methylPropDF = bsseq::getMeth(BSseq = exampleBSseqObj, type = "raw"),
    sample_names = bsseq::sampleNames(exampleBSseqObj))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MIRA.R
\docType{package}
\name{MIRA}
\alias{MIRA}
\alias{MIRA-package}
\title{Methylation-based Inference of Regulatory Activity (MIRA)}
\description{
MIRA is a score that infers regulatory activity of genomic elements
based on DNA methylation data. It assesses the degree of dip in methylation
level surrounding a regulatory site of interest, such as 
transcription factor binding sites.
This package provides functions for aggregating methylation 
data across region sets, in bins.
}
\references{
\url{http://github.com/databio}
}
\author{
Nathan Sheffield

John Lawson
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MIRA.R
\name{BSreadBiSeq}
\alias{BSreadBiSeq}
\title{Read in files from biseq meth caller}
\usage{
BSreadBiSeq(files, contrastList = NULL, cores = 4,
  returnAsList = FALSE)
}
\arguments{
\item{files}{a vector of file paths}

\item{contrastList}{Generally not needed for MIRA. 
A list of named character vectors, 
each with length equal to the number of items in files. 
These will translate into column names in the final table.}

\item{cores}{number of processors.}

\item{returnAsList}{Whether to return the output as a list 
or as one big data.table.}
}
\value{
Data from each input file joined together into one big data.table.
If returnAsList = TRUE, then input from each file will be 
in its own data.table in a list.
}
\description{
Parses the x/y format of methylation calls, 
splitting them into individual columns: "methylCount" column for
number of methylated reads for site and "coverage" column for total
number of reads covering that site. Input files should have the following
columns: "chr", "start", "end", "meth", "rate", "strand".
}
\details{
This can run into memory problems if there are too many files...
because of the way parallel lacks long vector support. The solution is
to just use a single core; or to pass mc.preschedule = FALSE; This
makes it so that each file is processed as a separate job. Much better.
}
\examples{
shortBSDTFile <- system.file("extdata", "shortRRBS.bed", package = "MIRA") 
shortBSDT <- BSreadBiSeq(shortBSDTFile)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{exampleRegionSet}
\alias{exampleRegionSet}
\title{A Granges object with Nrf1-binding regions.}
\format{A GRanges object}
\usage{
data(exampleRegionSet)
}
\description{
A GRanges object with a ranges corresponding to Nrf1 Chip-seq peaks
in the GM12878 B-lymphoblastoid cell line (GEO accession GSE31477, 
sample GSM935309). Only a subset of the ranges are used in 
this object and the regions were switched from hg19 to hg38.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotting.R
\name{plotMIRAProfiles}
\alias{plotMIRAProfiles}
\title{Plot summary methylation profile}
\usage{
plotMIRAProfiles(binnedRegDT, featID = unique(binnedRegDT[, featureID]),
  plotType = "line", colBlindOption = FALSE,
  sampleTypeColName = "sampleType")
}
\arguments{
\item{binnedRegDT}{A datatable with specific column names containing:
bin numbers(binnedRegionDT column), 
aggregated methylation values (methylProp column), 
name of the region set (featureID column), 
case/control column (sampleType column), 
sample name (sampleName column).}

\item{featID}{Region set names in a single string or vector of strings.}

\item{plotType}{Line or jitter (ggplot2).}

\item{colBlindOption}{If TRUE, function will plot with a color blind
friendly palette which could be helpful when plotting multiple colors.}

\item{sampleTypeColName}{character object. The name of the column that
contains sample type or condition information (eg case vs control).
Line color will be assigned based on this if it is present and there are
more than two unique sample types.}
}
\value{
A plot of class "gg"/ "ggplot" that shows MIRA profiles
}
\description{
Plot one or multiple methylation profiles. Displays each region set
in a different subplot.
If you only want to plot certain region sets,
subset with the `featID` parameter.
}
\examples{
data("exampleBins", package = "MIRA")
MIRAplot <- plotMIRAProfiles(binnedRegDT = exampleBins)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{bigBinDT1}
\alias{bigBinDT1}
\title{DNA methylation data for the "Applying MIRA to a Biological Question"
vignette (1st part).}
\format{A data.table, data.frame object}
\usage{
data(bigBinDT1)
}
\description{
A data.table with binned methylation data for the first part of
the "Applying MIRA to a Biological Question" vignette. 
Has data for 3 Ewing samples and 3 muscle-related 
samples (human skeletal myoblasts and other related
samples). It is the product of `aggregateMethyl`.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MIRA.R
\name{addMethPropCol}
\alias{addMethPropCol}
\title{Add column for proportion of methylation}
\usage{
addMethPropCol(BSDTList)
}
\arguments{
\item{BSDTList}{A bisulfite datatable or list of datatables 
with a column for number of methylated reads (methylCount) and 
a column for number of total reads 
(coverage) for each cytosine that was measured.}
}
\value{
The BSDTList but with extra `methylProp` column on each 
data.table in list.
}
\description{
Adding methylProp column that has proportion of reads that were 
methylated for each site based on number of methylated reads
divided by total number of reads.
Note: Assigns methylProp column by reference with ":="
}
\examples{
data("exampleBSDT", package = "MIRA")
exampleBSDT[, methylProp := NULL] # removing methylProp column
addMethPropCol(list(exampleBSDT))
}
